// FILE: RTCPaTraceAPI.h
//
// PURPOSE: This file is included by the client users of
//          PAL's tracing. This defines the TRACE macro and auxiliary macros.
//          NOTE: this file must be included AFTER the THM file.

#pragma once

//
// These are abbreviations for TRACE_LEVEL_... constants defined in evntrace.h in public sdk headers
//
#define TL_NONE     0
#define TL_FATAL    1
#define TL_ERROR    2
#define TL_WARN     3
#define TL_INFO     4
#define TL_VERBOSE  5
#define TL_NOISE    6

// for any platforms that don't support WPP (so far, these platforms have __GNUC__ in common)
#if defined(__GNUC__)
#include "rtcpal_tracing.h"
#else
#include <RTCTracing.h>
#endif
