// Create Framerelay
EXTERN_C
    HRESULT RtcPalVideoFrameRelayCreate(
    HANDLE* phFrameRelay
    );

// Destroy Framerelay
EXTERN_C
    HRESULT RtcPalVideoFrameRelayDestroy(
    HANDLE  hFrameRelay
    );

// Set Source Format
EXTERN_C
    HRESULT RtcPalVideoFrameRelaySetFormat(
    HANDLE  hFrameRelay,
    const RtcPalVideoFormat_t& SourceFormat
    );

// Create Encoder
EXTERN_C
    HRESULT RtcPalVideoFrameRelayCreateEncoder(
    HANDLE  hFrameRelay
    );

// Delete Encoder
EXTERN_C
    HRESULT RtcPalVideoFrameRelayDeleteEncoder(
    HANDLE  hFrameRelay
    );


// Start Encoder
EXTERN_C
    HRESULT RtcPalVideoFrameRelayStartEncoder(
    HANDLE  hFrameRelay,
    const MLE_Config* pConfig
    );

// Stop Encoder
EXTERN_C
    HRESULT RtcPalVideoFrameRelayStopEncoder(
    HANDLE  hFrameRelay
    );

// Query MLE parameters
EXTERN_C
    HRESULT RtcPalVideoFrameRelayGetMLEParameter(
    HANDLE  hFrameRelay,
    uint32_t ulParamType, 
    uint8_t* pbBlob, 
    uint32_t* pulBlobSize
    );

// Set MLE parameters
EXTERN_C
    HRESULT RtcPalVideoFrameRelaySetMLEParameter(
    HANDLE  hFrameRelay,
    uint32_t ulParamType,
    uint8_t* pbBlob,
    uint32_t ulBlobSize
    );

// Output consumption
EXTERN_C
    HRESULT RtcPalVideoFrameRelayGetEncoderOutput(
    HANDLE  hFrameRelay,
    MLE_EncodedUnit* pEncUnit
    );

// Stream headers
EXTERN_C
    HRESULT RtcPalVideoFrameRelayGetStreamHeader(
    HANDLE  hFrameRelay,
    UINT uiStreamId, 
    RtcPalVideoEncodedUnit_t * pEncUnit, 
    UINT uiMaxHeaderLen
    );

// Get frame queue lengths
EXTERN_C
    HRESULT RtcPalVideoFrameRelayGetQueuLengths(
    HANDLE  hFrameRelay,
    uint32_t* pulCurrentLength,
    uint32_t* pulMaxLength
    );

// Deliver frame
EXTERN_C
    HRESULT RtcPalVideoFrameRelayDeliverFrame(
    HANDLE hFrameRelay,
    RtcPalVideoRawFrame_t* pFrame
    );



