/* file defines public APIs so we can test the PAL  */

#pragma once

#ifndef __RTCPAL_ETW_API_H
#define __RTCPAL_ETW_API_H

#include "std.h"

#include "provider.h"
#include "session.h"
using namespace etw;

#include "util.h"

ULONG
EventRegister(
    _In_      LPCGUID ProviderId,
    _In_opt_  PENABLECALLBACK EnableCallback,
    _In_opt_  PVOID CallbackContext,
    _Out_     PREGHANDLE RegHandle
    );

ULONG
EventUnregister(
    _In_ REGHANDLE RegHandle
    );

ULONG
EventWrite(
    _In_     REGHANDLE RegHandle,
    _In_     PCEVENT_DESCRIPTOR EventDescriptor,
    _In_     ULONG UserDataCount,
    _In_opt_ PEVENT_DATA_DESCRIPTOR UserData
    );

ULONG EventWriteString(
    _In_ REGHANDLE RegHandle,
    _In_ UCHAR     Level,
    _In_ ULONGLONG Keyword,
    _In_ PCWSTR    String
);


ULONG
StartTrace(
    __out   PTRACEHANDLE SessionHandle,
    __in    LPCTSTR SessionName,
    __inout PEVENT_TRACE_PROPERTIES Properties
    );


ULONG
StartSession(
    __out   PTRACEHANDLE SessionHandle,
    __in    LPCTSTR SessionName,
    __inout PEVENT_TRACE_PROPERTIES Properties
    );

// If SessionHandle is NULL, then the EnableTrace is called in real time mode.
//
ULONG
EnableTrace(
    _In_ ULONG Enable,
    _In_ ULONG EnableFlag,
    _In_ ULONG EnableLevel,
    _In_ LPCGUID ControlGuid,
    _In_ TRACEHANDLE SessionHandle
    );

ULONG
StopTrace(
    _In_  TRACEHANDLE SessionHandle,
    _In_  LPCTSTR SessionName,
    _Out_ PEVENT_TRACE_PROPERTIES Properties
    );

#endif // __RTCPAL_ETW_API_H
