#pragma once

#ifndef __CONTROLRT_H__
#define __CONTROLRT_H__

#include <string>
#include <memory>
#include "rtcpal.h"
#include "etwrtcommon.h"

namespace etw {

class ShmManager;

class ControllerRT {
public:
    /// May throw boost::interprocess::interprocess_exception
    ControllerRT(const std::string & providerGuid);

    /// May throw boost::interprocess::interprocess_exception
    ControllerRT(const GUID & providerGuid);

    ~ControllerRT();

    ULONG StartTrace() const {
        std::string etlfile = ETWRT::GetEtlFullPath(m_providerGuid);
        return ETWRT::CreateFIFO(etlfile);
    }

    ULONG EnableTrace();
    ULONG DisableTrace();

private:
    std::string m_providerGuid;
    std::unique_ptr<ShmManager> m_shmMgr;
};

} // namespace etw

#endif // __CONTROLRT_H__
