/** \file throwable.h

    This file declares some functions which will throw ErrorT object if fails.
 */
#pragma once

#include "rtcpal.h"

namespace throwable
{
HANDLE create_event();
HANDLE create_file(const wchar_t* fileName);
HANDLE open_file(const wchar_t* fileName, DWORD dwDesiredAccess, DWORD flags);
void write_file(HANDLE hFile, void* pBuffer, ULONG uSize, uint32_t retryTimeoutMS, uint32_t retryIntervalMS);
void set_file_pos(HANDLE hFile, size_t offset);
void* malloc(size_t size);
void* calloc(size_t size);
RtcPalThreadHandle create_thread(RTCPAL_THREAD_START_ROUTINE func, void* param);
}
