#pragma once
/* --

Copyright (c) Microsoft Corporation. All rights reserved.

Module Name:

    mmvr_Common.h

Abstract:

    MMVR Comomon APIs.

Specification:

    http://livecommteam/sites/main/media/W15/Media%20Stack%20W15%20Plan%20Tracking/W15%20Video%20PAL%20Interface%20Design%20Doc.docx

--*/

#ifndef __MMVR_COMMON_H__
#define __MMVR_COMMON_H__

#ifdef __cplusplus
extern "C" {
#endif

// There are no MMVR common APIs yet - but there will be soon.

typedef int RtcPalRotationAngle_t;

typedef RECT RTCPAL_ZOOM_RECT;

typedef enum RtcPalSmartCropType {
    RtcPalFullAspectRatioCrop,
    RtcPalSmartCrop_FAR,
    RtcPalSmartCropPreview,
    RtcPalCenterSquareCrop,
    RtcPalSmartCrop_CS,
    
    // Deprecated values
    RtcPalNoSmartCrop = RtcPalFullAspectRatioCrop,
    RtcPalSmartCrop = RtcPalSmartCrop_FAR,
} RtcPalSmartCropType;

typedef enum RtcPalImageFitType {
    RtcPalFitImage_ByLetterBoxing,
    RtcPalFitImage_ByCropping,
    RtcPalFitImage_ByStretching,
} RtcPalImageFitType;

typedef struct _MMVR_ImageProcessingOption {
    RtcPalSmartCropType SmartCropType;
    BOOLEAN bHorizontalMirror;
    RtcPalRotationAngle_t ulRotateAngle;
    RTCPAL_ZOOM_RECT rcZoomRegion;
    RtcPalImageFitType fitType;
} MMVR_ImageProcessingOption, * PMMVR_ImageProcessingOption;

#ifdef __cplusplus
};
#endif

#endif


