
// Use this file for enabling optional media stack featuer for Mac OS build

// #define __RTCPAL_NO_TRACING__       1

#define __RTCPAL_FORCE_FILE_TRACING__ 1

// Use below macros to enable use secure string apis in mac
#define MS_RTC_USE_SECURE_STRING 1
#define MS_RTC_USE_SECURE_STRING_APIS 1

//globally enable profiling for Mac
//#define RTCPAL_ENABLE_PROFILE

// define this when PAL can support encrypt/decrypt a memory blob
#define RTCPAL_HAVE_MEMORY_ENCRYPTION   1

//turning on video
#define ENABLE_VIDEO                1

#if ENABLE_VIDEO
#define RTCPAL_ENABLE_VIDEO ENABLE_VIDEO
#endif

#if RTCPAL_ENABLE_VIDEO
//turning on VC1
#   define RTCPAL_ENABLE_VC1                  1
#   if RTCPAL_ENABLE_VC1
//turning off VC1 encoder
//    There is no way to disable/enable VC1 encoder in PAL as VC1 shared the same MLE interface with H264
//    you need to disable/enable it inside VideoDSP
//#       define RTCPAL_ENABLE_VC1_ENCODER          0
//turning on VC1 decoder
#       define RTCPAL_ENABLE_VC1_DECODER          1
#   endif //RTCPAL_ENABLE_VC1
#endif //RTCPAL_ENABLE_VIDEO

// define this when IPP library is available
#define RTCPAL_HAVE_IPP                 1

#define RTCPAL_DISABLE_MEDIA_METRICS    0

// If XCODE_BUILD_INTERNAL isn't defined, we'll build for ship
// Below macros should be consistent with \dev\media\project.mk
#if defined(XCODE_BUILD_INTERNAL)
#define ENABLE_DEBUGBLOB
#define MEDIA_PERF_ENABLED
#else  //XCODE_BUILD_INTERNAL
#define SHIP_BUILD                      1
#endif //XCODE_BUILD_INTERNAL

// Enable DTrace
#define RTCPAL_DTRACE_ENABLED           1

#define RTCPAL_VIDEODSP_VC1MLE_ENABLE   1
#define RTCPAL_VIDEODSP_VC1MLD_ENABLE   1
#define RTCPAL_VIDEODSP_H264MLE_ENABLE  1
#define RTCPAL_VIDEODSP_H264MLD_ENABLE  1
#define RTCPAL_VIDEODSP_SKYPE_ENABLE	1
#define RTCPAL_VIDEODSP_SKYPEDEC_ENABLE	1
#define RTCPAL_VIDEODSP_DXVA_ENABLE	    0
#define RTCPAL_VIDEODSP_SOFTWARE_DECODER_ENABLE	1

#define RTCPAL_AUDIO_HAVE_G722_CODEC    1
#define RTCPAL_AUDIO_HAVE_G7221_CODEC   1
#define RTCPAL_AUDIO_HAVE_G7222_CODEC   1
#define RTCPAL_AUDIO_HAVE_G711_CODEC    1
#define RTCPAL_AUDIO_HAVE_G726_CODEC    0   // IPP is not available yet on Mac
#define RTCPAL_AUDIO_HAVE_SIREN_CODEC   1
#define RTCPAL_AUDIO_HAVE_RTAUDIO_CODEC 1
#define RTCPAL_AUDIO_HAVE_SILK_CODEC    1
#define RTCPAL_SUPPORT_INBOX_DECODER    0

#define RTCPAL_HAVE_SSE                 1

#define RTCPAL_HAVE_NEON                0

#define RTCPAL_HAVE_FILESINK            1
#define RTCPAL_HAVE_FILESOURCE          1

#define RTCPAL_ENABLE_PSM               1
#define RTCPAL_SUPPORT_SSPI             1
#define RTCPAL_CPUFEATURE_NEON_ALWAYSAVAILABLE		0

// These CPU features are always available on Mac OS X
#define RTCPAL_CPUFEATURE_CMOV_ALWAYSAVAILABLE		1
#define RTCPAL_CPUFEATURE_MMX_ALWAYSAVAILABLE		1
#define RTCPAL_CPUFEATURE_SSE_ALWAYSAVAILABLE		1
#define RTCPAL_CPUFEATURE_SSE2_ALWAYSAVAILABLE		1
// These are not gauranteed to be present
#define RTCPAL_CPUFEATURE_SSE3_ALWAYSAVAILABLE		0
#define RTCPAL_CPUFEATURE_SSSE3_ALWAYSAVAILABLE		0
#define RTCPAL_CPUFEATURE_SSE4_1_ALWAYSAVAILABLE	0
#define RTCPAL_CPUFEATURE_SSE4_2_ALWAYSAVAILABLE	0
#define RTCPAL_CPUFEATURE_SSE4a_ALWAYSAVAILABLE		0
#define RTCPAL_CPUFEATURE_MSSE_ALWAYSAVAILABLE		0
#define RTCPAL_CPUFEATURE_MOVBE_ALWAYSAVAILABLE		0

#define RTCPAL_ENGINE_TIMER_PERIOD      50000 // 5 milliseconds

#define RTCPAL_USE_ARM_ASSEMBLY         0

// Log a heart beat message for diagnostics for every 128 frames
// If zero, the heart beat log will be compiled out
#define RTCPAL_VIDEO_HEARTBEAT_INTERVAL 0

// Disable listening only on the loopback address on mac
// This needs to be commented out closer to the release
//#define METRICS_SERVER_ENABLE_REMOTE_CONNECTIONS 1


// Video codec platform specific constants
#define MAX_MLE_NUM                     8
#define MAX_STREAM_NUM                  8
#define MAX_NUM_OF_LAYERS               3         
#define NALUNUMLIMIT                    100
#define MAX_SOURCE_NUM                  1024
#define MAX_SINK_NUM                    16
#define MAX_NUM_VP_COMPONENTS           10

#define MAXSTREAMNUM                    MAX_STREAM_NUM
#define MAXLAYERNUM                     MAX_NUM_OF_LAYERS
#define MAXSLICENUM                     NALUNUMLIMIT
