// Use this file for enabling feature set in media stack when building for Windows PC
#ifndef _RTCPAL_WINNT_PC_CONFIG_H_
#define _RTCPAL_WINNT_PC_CONFIG_H_

// define this when PAL can support encrypt/decrypt a memory blob
#define RTCPAL_HAVE_MEMORY_ENCRYPTION   1

#define RTCPAL_HAVE_WLANAPI             1

// define this to include AVMCU features in the binary
#if !defined(ARM)
#define RTCPAL_SUPPORT_AVMCU_SERVER     1
#else
#define RTCPAL_SUPPORT_AVMCU_SERVER     0
#endif

// define this to support fax detector
// ARMTODO
#if !defined(ARM)
#define RTCPAL_SUPPORT_FAX_DETECTOR     1
#else
#define RTCPAL_SUPPORT_FAX_DETECTOR     0
#endif

#if RTCPAL_SUPPORT_AVMCU_SERVER
#define RTCPAL_SUPPORT_ECHO_DETECTOR    1
#define RTCPAL_SUPPORT_NOISE_DETECTOR   1
#endif

// define this when IPP library is available
#if !defined(ARM)
#define RTCPAL_HAVE_IPP                 1
#else
#define RTCPAL_HAVE_IPP                 0
#endif

// Enable typing sound suppression
#if !defined(ARM)
#define RTCPAL_AUDIODSP_AEC_TYPING_SUPPRESSION_ENABLED  1
#else
#define RTCPAL_AUDIODSP_AEC_TYPING_SUPPRESSION_ENABLED  0
#endif

#if !defined(ARM)
#define RTCPAL_AUDIO_HAVE_G722_CODEC    1
#define RTCPAL_AUDIO_HAVE_G7221_CODEC   1
#define RTCPAL_AUDIO_HAVE_G7222_CODEC   1
#define RTCPAL_AUDIO_HAVE_G711_CODEC    1
#define RTCPAL_AUDIO_HAVE_G726_CODEC    1
#define RTCPAL_AUDIO_HAVE_SIREN_CODEC   1
#define RTCPAL_AUDIO_HAVE_RTAUDIO_CODEC 1
#define RTCPAL_AUDIO_HAVE_SILK_CODEC    1
#define RTCPAL_VIDEODSP_H264MLE_ENABLE  1
#define RTCPAL_VIDEODSP_H264MLD_ENABLE  1
#define RTCPAL_VIDEODSP_SKYPE_ENABLE    1
#define RTCPAL_VIDEODSP_SKYPEDEC_ENABLE 1
#define RTCPAL_VIDEODSP_DXVA_ENABLE     1
#else
#define RTCPAL_AUDIO_HAVE_G722_CODEC    1
#define RTCPAL_AUDIO_HAVE_G7221_CODEC   0
#define RTCPAL_AUDIO_HAVE_G7222_CODEC   0
#define RTCPAL_AUDIO_HAVE_G711_CODEC    1
#define RTCPAL_AUDIO_HAVE_G726_CODEC    0
#define RTCPAL_AUDIO_HAVE_SIREN_CODEC   1
#define RTCPAL_AUDIO_HAVE_SILK_CODEC    1
#define RTCPAL_AUDIO_HAVE_RTAUDIO_CODEC 0
#define RTCPAL_VIDEODSP_H264MLE_ENABLE  0
#define RTCPAL_VIDEODSP_H264MLD_ENABLE  0
#define RTCPAL_VIDEODSP_SKYPE_ENABLE    0
#define RTCPAL_VIDEODSP_SKYPEDEC_ENABLE 0
#define RTCPAL_VIDEODSP_DXVA_ENABLE     0
#endif

#define RTCPAL_AUDIODSP_AEC_HAVE_SQM 1

#if !defined(BUILD_FOR_IE)
#define RTCPAL_VIDEODSP_VC1MLE_ENABLE   1
#define RTCPAL_VIDEODSP_VC1MLD_ENABLE   1
#else
#define RTCPAL_VIDEODSP_VC1MLE_ENABLE   0
#define RTCPAL_VIDEODSP_VC1MLD_ENABLE   0
#endif
#define RTCPAL_VIDEODSP_SOFTWARE_DECODER_ENABLE	1

#define RTCPAL_HAVE_FILESOURCE          1
#define RTCPAL_HAVE_FILESINK            1

#define RTCPAL_OFFLINE_DATA_CONV_AVAILABLE 1

// Turning off SetRTCPresence across all the builds.
//
// For modern, we can't take it due to its DeviceIoControl dependency.
// For classic, it is already broken in W14. It will be reimplemented
// in PAL later.
// #define RTMEDIA_ENABLE_PRESENCE     1

#if !defined(ARM)
#define RTCPAL_HAVE_SSE                 1
#define RTCPAL_HAVE_NEON                0
#else
#define RTCPAL_HAVE_SSE                 0
#define RTCPAL_HAVE_NEON                1
#endif

#if defined(ARM)
#define RTCPAL_ENABLE_PSM               0
#else
#define RTCPAL_ENABLE_PSM               1
#endif

#define RTCPAL_SUPPORT_SSPI             1

#define RTCPAL_SUPPORT_INBOX_DECODER    1

#define RTCPAL_CPUFEATURE_NEON_ALWAYSAVAILABLE		0

#ifdef _M_X64
// These CPU features are always available on x64
#define RTCPAL_CPUFEATURE_CMOV_ALWAYSAVAILABLE		1
#define RTCPAL_CPUFEATURE_MMX_ALWAYSAVAILABLE		1
#define RTCPAL_CPUFEATURE_SSE_ALWAYSAVAILABLE		1
#else
#define RTCPAL_CPUFEATURE_CMOV_ALWAYSAVAILABLE		0
#define RTCPAL_CPUFEATURE_MMX_ALWAYSAVAILABLE		0
#define RTCPAL_CPUFEATURE_SSE_ALWAYSAVAILABLE		0
#endif
#define RTCPAL_CPUFEATURE_SSE2_ALWAYSAVAILABLE		0
#define RTCPAL_CPUFEATURE_SSE3_ALWAYSAVAILABLE		0
#define RTCPAL_CPUFEATURE_SSSE3_ALWAYSAVAILABLE		0
#define RTCPAL_CPUFEATURE_SSE4_1_ALWAYSAVAILABLE	0
#define RTCPAL_CPUFEATURE_SSE4_2_ALWAYSAVAILABLE	0
#define RTCPAL_CPUFEATURE_SSE4a_ALWAYSAVAILABLE		0
#define RTCPAL_CPUFEATURE_MSSE_ALWAYSAVAILABLE		0
#define RTCPAL_CPUFEATURE_MOVBE_ALWAYSAVAILABLE		0

#define RTCPAL_ENGINE_TIMER_PERIOD      50000 // 5 milliseconds

#define RTCPAL_USE_ARM_ASSEMBLY         0

// Log a heart beat message in WPP for diagnostics for every 256 frames
// If zero, the heart beat log will be compiled out
#define RTCPAL_VIDEO_HEARTBEAT_INTERVAL 256

// Video codec platform specific constants
#if !defined(ARM)
#define MAX_MLE_NUM                     8
#define MAX_STREAM_NUM                  8
#define MAX_NUM_OF_LAYERS               3         
#define NALUNUMLIMIT                    100
#define MAX_SOURCE_NUM                  1024
#define MAX_SINK_NUM                    16
#define MAX_NALUS_PER_SAMPLE            1024
#define MAX_NUM_VP_COMPONENTS           10
#else
#define MAX_MLE_NUM                     3
#define MAX_STREAM_NUM                  4
#define MAX_NUM_OF_LAYERS               3
#define NALUNUMLIMIT                    8
#define MAX_SOURCE_NUM                  2
#define MAX_SINK_NUM                    8
#define MAX_NALUS_PER_SAMPLE            1024
#define MAX_NUM_VP_COMPONENTS           4
#endif

#define MAXSTREAMNUM                    MAX_STREAM_NUM
#define MAXLAYERNUM                     MAX_NUM_OF_LAYERS
#define MAXSLICENUM                     NALUNUMLIMIT

// May require tweaking for ARM vs not ARM
#define RTCPAL_MAX_ENCODER_COUNT        4
#define RTCPAL_NUM_INBOX_ENCODER_TYPES  4

#endif


