// Use this file for enabling feature set in media stack when building for Windows Phone
#ifndef _RTCPAL_WINPHONE_CONFIG_H_
#define _RTCPAL_WINPHONE_CONFIG_H_

// Define this when PAL can support encrypt/decrypt a memory blob. Rationale:
// If there is an app crash a memory dump may be uploaded to Microsoft.
// We store the credentials including http proxy credentials in media manager (in memory)
// and in some cases these creds may be your domain credentials.  We do not want this
// data unencrypted in the uploaded memory dump, and expose user credentials.
#define RTCPAL_HAVE_MEMORY_ENCRYPTION   1

#define RTCPAL_HAVE_WLANAPI             1

// define this to include AVMCU features in the binary
#define RTCPAL_SUPPORT_AVMCU_SERVER     0

// define this to support fax detector
#define RTCPAL_SUPPORT_FAX_DETECTOR     0

#if RTCPAL_SUPPORT_AVMCU_SERVER
    #define RTCPAL_SUPPORT_ECHO_DETECTOR    1
    #define RTCPAL_SUPPORT_NOISE_DETECTOR   1
#endif

// Disable typing sound suppression
#define RTCPAL_AUDIODSP_AEC_TYPING_SUPPRESSION_ENABLED  0

#define RTCPAL_AUDIO_HAVE_G722_CODEC    1
#define RTCPAL_AUDIO_HAVE_G7221_CODEC   0
#define RTCPAL_AUDIO_HAVE_G7222_CODEC   0
#define RTCPAL_AUDIO_HAVE_G711_CODEC    1
#define RTCPAL_AUDIO_HAVE_G726_CODEC    0
#define RTCPAL_AUDIO_HAVE_SIREN_CODEC   1
#define RTCPAL_AUDIO_HAVE_RTAUDIO_CODEC 0
#define RTCPAL_AUDIO_HAVE_SILK_CODEC    1
#define RTCPAL_AUDIODSP_AEC_HAVE_SQM    0

#if !defined(BUILD_FOR_IE)
#define RTCPAL_VIDEODSP_VC1MLE_ENABLE   1
#else
#define RTCPAL_VIDEODSP_VC1MLE_ENABLE   0
#endif
#define RTCPAL_VIDEODSP_VC1MLD_ENABLE   0
#define RTCPAL_VIDEODSP_H264MLE_ENABLE  1
#define RTCPAL_VIDEODSP_H264MLD_ENABLE  0
#define RTCPAL_VIDEODSP_SKYPE_ENABLE	1
#define RTCPAL_VIDEODSP_SKYPEDEC_ENABLE	1
#define RTCPAL_VIDEODSP_DXVA_ENABLE	    0
#define RTCPAL_VIDEODSP_SOFTWARE_DECODER_ENABLE	0

#define RTCPAL_OFFLINE_DATA_CONV_AVAILABLE 1

#define RTCPAL_HAVE_FILESOURCE          0
#define RTCPAL_HAVE_FILESINK            0

#if !defined(ARM)
#define RTCPAL_HAVE_SSE                 1
#define RTCPAL_HAVE_IPP                 1
#define RTCPAL_HAVE_NEON                0
#else
#define RTCPAL_HAVE_SSE                 0
#define RTCPAL_HAVE_IPP                 0
#define RTCPAL_HAVE_NEON                1
#endif

#define RTCPAL_SUPPORT_INBOX_DECODER    1

#define RTCPAL_ENABLE_PSM               0

#define RTCPAL_SUPPORT_SSPI             1

#ifdef ARM
#define RTCPAL_CPUFEATURE_NEON_ALWAYSAVAILABLE		1
#else
#define RTCPAL_CPUFEATURE_NEON_ALWAYSAVAILABLE		0

#define RTCPAL_CPUFEATURE_CMOV_ALWAYSAVAILABLE		1
#define RTCPAL_CPUFEATURE_MMX_ALWAYSAVAILABLE		1
#define RTCPAL_CPUFEATURE_SSE_ALWAYSAVAILABLE		1
#define RTCPAL_CPUFEATURE_SSE2_ALWAYSAVAILABLE		0
#define RTCPAL_CPUFEATURE_SSE3_ALWAYSAVAILABLE		0
#define RTCPAL_CPUFEATURE_SSSE3_ALWAYSAVAILABLE		0
#define RTCPAL_CPUFEATURE_SSE4_1_ALWAYSAVAILABLE	0
#define RTCPAL_CPUFEATURE_SSE4_2_ALWAYSAVAILABLE	0
#define RTCPAL_CPUFEATURE_SSE4a_ALWAYSAVAILABLE		0
#define RTCPAL_CPUFEATURE_MSSE_ALWAYSAVAILABLE		0
#define RTCPAL_CPUFEATURE_MOVBE_ALWAYSAVAILABLE		0

#endif

#define RTCPAL_ENGINE_TIMER_PERIOD      50000 // 5 milliseconds

#define RTCPAL_USE_ARM_ASSEMBLY         0

// Log a heart beat message for diagnostics for every 128 frames
// If zero, the heart beat log will be compiled out
#define RTCPAL_VIDEO_HEARTBEAT_INTERVAL 0

// Video codec platform specific constants
#define MAX_MLE_NUM                     3
#define MAX_STREAM_NUM                  1
#define MAX_NUM_OF_LAYERS               2
#define NALUNUMLIMIT                    8
#define MAX_SOURCE_NUM                  2
#define MAX_SINK_NUM                    4
#define MAX_NUM_VP_COMPONENTS           4

#define MAXSTREAMNUM                    MAX_STREAM_NUM
#define MAXLAYERNUM                     MAX_NUM_OF_LAYERS
#define MAXSLICENUM                     NALUNUMLIMIT

#endif

// Disable listening only on the loopback address on Windows phone
#define METRICS_SERVER_ENABLE_REMOTE_CONNECTIONS 1

