#ifndef __RTCPAL__
#define __RTCPAL__

#pragma once

#if !defined(RTCPAL_VIDEO_FOR_SKYPE) || defined(_MAC) || defined(__IPHONE__) || defined(ANDROID) || defined (__linux)

#include <rtcpal_compiler.h>

#include <rtcpal_linkage.h>
#include <rtcpal_platform_specific.h>

#if defined(RTCPAL_ARCH_X86) || defined(RTCPAL_ARCH_X64)
    #include <arch/rtcpal_x86.h>
#elif defined(RTCPAL_ARCH_ARM)
    #include <arch/rtcpal_arm.h>
#else
    #error "Unsupported CPU architecture"
#endif

#include <rtcpal_base.h>
#undef ASSERT
#define ASSERT RTCPAL_ASSERT
#ifndef RTCPAL_VIDEO_FOR_SKYPE
#include <rtcpal_network.h>
#include <rtcpal_crypt.h>
#endif
#include <rtcpal_crt.h>
#include <rtcpal_data_structure.h>

#include <rtcpal_aio.h>
#include <rtcpal_logging.h>

#include <rtcpal_filesource.h>

#include <rtcpal_systemmetrics.h>
#include <rtcpal_workitem.h>

#if !defined(__linux)
#include <rtcpal_apis_video.h>
#endif

#ifndef BAIL_ON_WIN32_ERROR
    #define BAIL_ON_WIN32_ERROR(dwErr)  if (dwErr != NO_ERROR) { goto error; }
#endif

#if defined(__GNUC__) && defined(__RTCPAL_IMPL__)
    // undefine SAL keyword __reserved which conflicts with many other header files
    #undef __reserved
#endif

#if !defined(__linux)
#include <rtcpal_apis_AV_devices.h>
#include <rtcpal_avwriter.h>

// MUST be included after <rtcpal_apis_av_devices.h>
#include <rtcpal_apis_virtual_device.h>
#endif

// For ADSP configuration
#include <rtcpal_adsp_config.h>

#ifndef FIELDOFFSET
#define FIELDOFFSET(type,field)   RTCPAL_FIELD_OFFSET(type,field)
#endif

#include <rtcpal_tracing.h>

#ifndef RTCPAL_VIDEO_FOR_SKYPE
#if !defined(__linux)
#include <rtcpal_reference.h>
#endif
#endif

#ifdef __cplusplus
#include <rtcpal_thread_safe.h>
#endif

#else
#include <rtcpal_windows.h>
#include <tchar.h>
#include <inttypes_msc.h>

// Add macros used by headers included by rtcpal_apis_video.h
#include <rtcpal_types.h>
#define RTC_CLASS_LINKAGE
#define RTCPAL_NOTHROW
#define RTCPAL_STDCALL
#define RTCAPI
//RTC_CLASS_LINKAGE   RTCPAL_STDCALL

// Duplicated from rtcpal_platform_specific.h since we cannot re-include rtcpal_private.h
#if defined(_WIN32_WINNT)
	#include <products/rtcpal_winnt_pc_config.h>
#elif defined(_WIN32_WCE)
    #include <products/rtcpal_wince_config.h>
#elif defined(WINPHONE)
    #include <products/rtcpal_winphone_config.h>

    // On WINPHONE builds we need this remap, since Core System / Mobile Core doesn't have WaitForMultipleObjects
    #define WaitForMultipleObjects(a,b,c,d) WaitForMultipleObjectsEx((a),(b),(c),(d),FALSE)
#else
	#error "Unknown Platform"
#endif

#include <rtcpal_apis_video.h>
#include "RtcPalInstrument.h"
#include "sliq_global.h"
#endif

#if defined(__linux)
#include <rtcpal_vs.h>
#include <unix/rtcpal_linux_util.h>

#if defined(__cplusplus)

#include "unix/CertOpenssl.h"
#include "unix/CertStoreOpenssl.h"
#include "rtcpal_std.h"

#define Certificate RtcPalCertificate
#define CertificateStore RtcPalCertificateStore

#endif// __cplusplus

#endif // __linux

#include "unix/rtcpal_util.h"

#endif // __RTCPAL__
