#pragma once

typedef enum RtcPalADSPConfigType_e
{
  RTCPAL_ADSP_CONFIG_Stereo = 0,        // Default stereo configuration
  RTCPAL_ADSP_CONFIG_RESAMPLER_QUALITY, // Resampler Quality
  RTCPAL_ADSP_CONFIG_PSM,               // PSM
  RTCPAL_ADSP_CONFIG_TypingSuppression, // Typing Suppression
  RTCPAL_ADSP_CONFIG_DeviceSamplingRate, // Device (source/sink) sampling rate
  RTCPAL_ADSP_CONFIG_PlatformIsSlate,    // Chassis type determination
  RTCPAL_ADSP_CONFIG_AGCSettings,    // Chassis type determination
  RTCPAL_ADSP_CONFIG_AUDIO_DEVICE_LATENCY, // Average audio device latency
  RTCPAL_ADSP_CONFIG_SILKComplexity,    // Set SILK complexity depends on platforms
  RTCPAL_ADSP_CONFIG_JITTER_HISTOGRAM,
  RTCPAL_ADSP_CONFIG_LAST               // Please keep this one last
} RtcPalADSPConfigType_e;

#ifdef __cplusplus
extern "C" {
#endif

HRESULT RtcPalGetADSPConfig(
    RtcPalADSPConfigType_e eType,
    void *pData,
    size_t uDataSize
    );

uint32_t RtcPalGetADSPLogFolder(
    char* szBuffer, 
    uint32_t uBufferSize
    );

#ifdef __cplusplus
}
#endif

