
#define CONCAT1(a, b) CONCAT2(a,b)
#define CONCAT2(a, b) a ## b

#if defined (_UNIX_IPHONE) //iOS

// MACRO_ASM_LOAD_ADDR target-reg, data-label, instruction-label
// This only works for ARM, not THUMB
.macro MACRO_ARM_LOAD_ADDR
    //USE pc relative addressing. 16 is the offset of pc (8) plus two mov
    movw $0, :lower16:($1-($2+16))
    movt $0, :upper16:($1-($2+16))
    add  $0, pc, $0
.endmacro

.macro MACRO_ARM_LOAD_ADDR_EQ
    movweq $0, :lower16:($1-($2+16))
    movteq $0, :upper16:($1-($2+16))
    addeq  $0, pc, $0
.endmacro

.macro MACRO_ARM_LOAD_ADDR_NE
    movwne $0, :lower16:($1-($2+16))
    movtne $0, :upper16:($1-($2+16))
    addne  $0, pc, $0
.endmacro

#define DATA_SECTION
#define FUNC_NAME(n)  _##n
#define ARM_LOAD_ADDR(r, m) CONCAT1(Lrtc, __LINE__): MACRO_ARM_LOAD_ADDR r, m, CONCAT1(Lrtc, __LINE__)
#define ARM_LOAD_ADDR_EQ(r, m) CONCAT1(Lrtc, __LINE__): MACRO_ARM_LOAD_ADDR_EQ r, m, CONCAT1(Lrtc, __LINE__)
#define ARM_LOAD_ADDR_NE(r, m) CONCAT1(Lrtc, __LINE__): MACRO_ARM_LOAD_ADDR_NE r, m, CONCAT1(Lrtc, __LINE__)
#define ASM_LABEL(n) CONCAT1(L_, n) //llvm local label is of form Lxxx

#elif defined(ANDROID) || defined(__linux)

#define DATA_SECTION    .data
#define FUNC_NAME(n)    n
#define ARM_LOAD_ADDR(r, m) ldr r, =##m
#define ARM_LOAD_ADDR_EQ(r, m) ldreq r, =##m
#define ARM_LOAD_ADDR_NE(r, m) ldrne r, =##m
#define ASM_LABEL(n) CONCAT1(.L_, n) //gcc local label is of form .Lxxx
#else

#error Unknown ARM platform.

#endif
