
// Wrap over CRT function
// Windows CE lack of standard CRT function time() and signal()

#ifndef __RTCPAL_CRT_H__
#define __RTCPAL_CRT_H__

// BUGBUG: remove this once MACBU and RTCPAL are merged
#ifndef RTC_CLASS_LINKAGE
#define RTC_CLASS_LINKAGE
#define RTCAPI
#endif


#include <stdlib.h>

#if defined(_MSC_VER)
    #ifdef UNDER_CE
    #pragma warning(disable:4231)
    #endif

    #include <stdio.h>
    #include <ctype.h>
    #include <tchar.h>
    #include <windows/rtcpal_wc16.h>

    #define rtcpal_unlink   _unlink
    #define rtcpal_close    _close
    #define rtcpal_read     _read
    #define rtcpal_write    _write
    EXTERN_C
    int
    __cdecl
    rtcpal_open(const char * fname, int oflag, ...);

#if defined(WINPHONE)
    #define vsnprintf_s _vsnprintf_s
#endif

#elif defined(__GNUC__)
    #include <string.h>
    #include <strings.h>
    #include <ctype.h>
    #include <unix/rtcpal_wc16.h>

    #if defined(_UNICODE) || defined(UNICODE)
    #include <rtcpal_unicode.h>
    #else
    #include <rtcpal_sbcs.h>
    #endif // _UNICODE

    #define vsnprintf_s _vsnprintf_s
    
    #if defined(ANDROID) || defined (__linux)
        #include <unix/winapi/crt/safecrt.h>
        #include <unix/winapi/intsafe.h>

        // support all string functions. Otherwise, some header files like boost asio
        // that use these functions will fail to compile.
        #define STRSAFE_NO_DEPRECATE
        #include <unix/winapi/strsafe.h>
        #ifndef INT32_MAX 
            #define INT32_MAX       2147483647L
        #endif //INT32_MAX

        #ifndef INT32_MIN //MBU_TARGET_RT_MAC_OS
            #define INT32_MIN       (-2147483647L - 1)
        #endif //INT32_MIN

        #ifndef UINT32_MAX
            #define UINT32_MAX      0xffffffffUL
        #endif //UINT32_MAX

        #ifndef INT8_MAX
            #define INT8_MAX        127
        #endif //INT8_MAX

        #ifndef INT8_MIN
            #define INT8_MIN        (-127 - 1)
        #endif //INT8_MIN

        #ifndef UINT8_MAX
            #define UINT8_MAX       0xff
        #endif //UINT8_MAX

        #ifndef INT16_MAX
            #define INT16_MAX       32767
        #endif //INT16_MAX

        #ifndef INT16_MIN
            #define INT16_MIN       (-32767 - 1)
        #endif //INT16_MIN

        #ifndef UINT16_MAX
            #define UINT16_MAX      0xffff
        #endif //UINT16_MAX

        #ifndef INT64_MAX
            #define INT64_MAX       9223372036854775807LL
        #endif //INT64_MAX

        #include <ctype.h>
	    #define iswascii(x)     isascii(x) 
#if !defined(__linux)
        #define __isascii(x)    isascii(x)
#endif
        typedef HANDLE          HMMIO;
        typedef struct {} MMIOINFO;
        typedef struct {} MMCKINFO;
    #else
        #include <mbusafecrt.h>

        #define __isascii(x)    isascii(x)
    #endif

    #define rtcpal_unlink   unlink
    #define rtcpal_open     open
    #define rtcpal_close    close
    #define rtcpal_read     read
    #define rtcpal_write    write
    #define O_BINARY        0
    #define O_TEXT          0
#else
    #error "Unsupported C/C++ compiler"
#endif  // _MSC_VER

EXTERN_C
LONG64
rtcpal_lseek(
    int fd,
    LONG64 offset,
    int origin
    );

EXTERN_C
int
__cdecl
rtcpal_wopen(const WCHAR * fname, int oflag, ...);

#endif // __RTCPAL_CRT_H__

