// FILE: rtcpal_device_handles.h

// PURPOSE:
// This header file helps avoid definition conflicts in device code that is
// being ported in several phases into the RTCPAL environment.
// Please keep this header file free of any other dependencies,
// so that subsystems that need these primitive definitions can get them
// by including this header file and nothing else.


#ifndef __RTCPAL_DEVICE_HANDLES_H__
#define __RTCPAL_DEVICE_HANDLES_H__



// $$REVIEW - We can probably collapse all of these handles to a single HRDVHANDLE type and a single
//            RVDCloseHandle API to intelligently free up the associated resources.  But for now, keep
//            them separated so it'll make the code a bit more readable.
#ifndef HRVDPLAT
#define HRVDPLAT    void*
#endif

#ifndef HRVDDEVICE
#define HRVDDEVICE  void*
#endif


#ifndef HRVDDEVICEUNIQUEID
#define HRVDDEVICEUNIQUEID  void*
#endif


#ifndef HRVDPLATCB
#define HRVDPLATCB  void*
#endif

#ifndef HRVDDEVCB
#define HRVDDEVCB   void*
#endif

#ifndef HRVDAUDSTRM
#define HRVDAUDSTRM void*
#endif


#ifndef RVDMAX_STRINGMSG
#define RVDMAX_STRINGMSG        256
#endif

#ifndef HRVDHID
#define HRVDHID     void*
#endif

// =============================================================================
// Video Handle Definitions
// =============================================================================

typedef struct RtcPalVideoPlatform*       HPALVIDEOPLATFORM;
typedef struct RtcPalVideoSource*         HPALVIDEOSOURCE;
typedef struct RtcPalVideoPreview*        HPALVIDEOPREVIEW;
typedef struct RtcPalVideoEncoder*        HPALVIDEOENCODER;
typedef struct RtcPalVideoAnalyzer*       HPALVIDEOANALYZER;



#endif
