/*++

Abstract:

    MS Visual C++ specific definitions

Author:

Revision History:

--*/

// Enforce MSDK clean CRT/ATL for non-PAL component
#if !defined(__RTCPAL_IMPL__) && !defined(RTCPAL_CLASSIC_WIN32_APP)
    #ifndef _CRT_USE_TAILORED_APP
        #define _CRT_USE_TAILORED_APP   1
    #endif

    #ifndef _ATL_USE_TAILORED_APP
        #define _ATL_USE_TAILORED_APP   1
        #define ATL_USE_TAILORED_APP    1
    #endif

    #ifndef _ATL_NO_SERVICE
        #define _ATL_NO_SERVICE         1
    #endif
#endif

// For standard CRT declarations like size_t, intptr_t, etc.

#include <crtdefs.h>

#ifndef __RTCPAL_MSC_H__
#define __RTCPAL_MSC_H__

#undef RTCPAL_CDECL
#define RTCPAL_CDECL        __cdecl

#undef RTCPAL_STDCALL
#define RTCPAL_STDCALL      __stdcall

#undef RTCPAL_THISCALL
#define RTCPAL_THISCALL     __thiscall

#undef RTCPAL_FASTCALL
#define RTCPAL_FASTCALL     __fastcall

#undef RTCPAL_NOTHROW
#define RTCPAL_NOTHROW      throw()

#undef RTCPAL_NOTHROW_IMPL
#define RTCPAL_NOTHROW_IMPL throw()

#undef RTCPAL_NOVTABLE
#define RTCPAL_NOVTABLE     __declspec(novtable)

#undef RTCPAL_FORCEINLINE 
#define RTCPAL_FORCEINLINE  __forceinline

#undef RTCPAL_SELECTANY
#define RTCPAL_SELECTANY    __declspec(selectany)

#undef RTCPAL_DLL_EXPORT
#define RTCPAL_DLL_EXPORT   __declspec(dllexport)

#undef RTCPAL_DLL_IMPORT
#define RTCPAL_DLL_IMPORT   __declspec(dllimport)

#undef RTCPAL_TYPE_ALIGNMENT
#define RTCPAL_TYPE_ALIGNMENT(t)    __alignof(t)

#undef RTCPAL_ALIGNED
#define RTCPAL_ALIGNED(val) __declspec(align(val))

#undef RtcPalDebugBreak

// #define RtcPalDebugBreak()          do { if (::IsDebuggerPresent()) __debugbreak(); } while(0)
#define RtcPalDebugBreak()          __debugbreak()

// for MSC CPU architecture macro, see
//      http://msdn.microsoft.com/en-us/library/aa273918(v=vs.60).aspx
//      http://msdn.microsoft.com/en-us/library/b0084kay(v=vs.80).aspx
//
#ifdef _M_IX86
    // P6 or blend      _M_IX86 = 600
    // Pentium          _M_IX86 = 500
    // 486              _M_IX86 = 400
    // 386              _M_IX86 = 300
    #define RTCPAL_ARCH_X86     _M_IX86
#elif defined(_M_X64)
    // Always _M_X64 = 100
    #define RTCPAL_ARCH_X64     _M_X64
#elif _M_ARM
    #define RTCPAL_ARCH_ARM     _M_ARM
#elif defined(_M_PPC) || defined(_M_MPPC)
    //  PowerPC 601     _M_PPC = 601
    //  PowerPC 603     _M_PPC = 603
    //  PowerPC 604     _M_PPC = 604
    //  PowerPC 620     _M_PPC = 620
    #ifdef _M_PPC
        #define RTCPAL_ARCH_PPC _M_PPC
    #else
        #define RTCPAL_ARCH_PPC _M_MPPC
    #endif
#elif defined(_M_MRX000)
    // R4000    _M_MRX000 = 4000
    // R4100    _M_MRX000 = 4100
    // ...
    #define RTCPAL_ARCH_MIPS _M_MRX000
#else
    #error "Unknown CPU architecture"
#endif

#endif // __RTCPAL_MSC_H__

