#pragma once
#ifndef __RTCPAL_STD_H__
#define __RTCPAL_STD_H__

#if defined (__GNUC__) && !defined (__clang__)
// for gcc 4.9.0, GCC_VERSION will be 40900
#define GCC_VERSION (__GNUC__ * 10000  + __GNUC_MINOR__ * 100 + __GNUC_PATCHLEVEL__)
#endif // __GNUC__


// Some C++ compiler doesn't support <codecvt>.
// for example, GCC with version < 4.9 doesn't support it.
// not sure which GCC starts to support it.

#if defined(__clang__) || (GCC_VERSION > 50000)
#define RTCPAL_CODECVT_SUPPORT 1
#endif //__clang__ || GCC_VERSION

// Some C++ compiler doesn't support std::make_unique<T>.
// for example, GCC with version < 4.9 doesn't support it.
#if defined (__GNUC__) && !defined (__clang__)

#if GCC_VERSION < 40900

#include <memory>
namespace std {
    // make_unique is C++14 feature, compiler like gcc 4.8.x doesn't support this
    template<class _Tp, class... _Args>
    std::unique_ptr<_Tp> make_unique(_Args&&... __args)
    {
        return unique_ptr<_Tp>(new _Tp(std::forward<_Args>(__args)...));
    }
}
#endif // GCC_VERSION
#endif // __GNUC__

#endif // __RTCPAL_STD_H__