#pragma once

#ifndef __RTCPAL_VS_H__
#define __RTCPAL_VS_H__

#if defined(__GNUC__)

#ifdef  __cplusplus

#include <string>

#endif


/***************** wincon.h Entrypoints **********************************/

#define CTRL_C_EVENT        0
#define CTRL_BREAK_EVENT    1
#define CTRL_CLOSE_EVENT    2
// 3 is reserved!
// 4 is reserved!
#define CTRL_LOGOFF_EVENT   5
#define CTRL_SHUTDOWN_EVENT 6


#define DECLSPEC_CACHEALIGN 

#define selectany weak

// defined in Windows Kits\8.1\Include\shared\ntdef.h
typedef CONST CHAR * LPCCH;


#define _getch getchar


#ifdef  __cplusplus
extern "C" {
#endif


void TraceDebugPrint(const char* filename, int linno, ULONG DebugPrintLevel, const char* format, ...);

#define TraceDebugImpl(...) TraceDebugPrint(__FILE__, __LINE__, __VA_ARGS__)

#undef TraceDebug
//#if DBG
// Always support tracing for debugging
#define TraceDebug(x) TraceDebugImpl x
//#else
//#define TraceDebug(x)
//#endif // DBG


DWORD
GetEnvironmentVariableW(
    LPCTSTR lpName,
    LPTSTR lpBuffer,
    DWORD nSize
    );

DWORD
GetEnvironmentVariableA(
    LPCSTR lpName,
    LPSTR lpBuffer,
    DWORD nSize
    );

HRESULT
IsValidURLW(void*,
    LPCWSTR szURL,
    DWORD dwReserved
    );

HRESULT
IsValidURLA(void*,
    LPCSTR szURL,
    DWORD dwReserved
    );

typedef BOOL (*PHANDLER_ROUTINE)(DWORD CtrlType);

BOOL
SetConsoleCtrlHandler(
    PHANDLER_ROUTINE HandlerRoutine,
    BOOL Add
    );


#ifdef UNICODE

#define GetEnvironmentVariable GetEnvironmentVariableW
#define IsValidURL IsValidURLW


#else

#define GetEnvironmentVariable GetEnvironmentVariableA
#define IsValidURL IsValidURLA

#endif // UNICODE



#ifdef  __cplusplus
}
#endif



#ifdef __cplusplus

namespace std
{
    // _Hash_seq ported from VS2013
    inline size_t _Hash_seq(const unsigned char *_First, size_t _Count)
    { 
        const size_t _FNV_offset_basis = 14695981039346656037ULL;
        const size_t _FNV_prime = 1099511628211ULL;

        size_t _Val = _FNV_offset_basis;
        for (size_t _Next = 0; _Next < _Count; ++_Next)
        {   // fold in another byte
            _Val ^= (size_t)_First[_Next];
            _Val *= _FNV_prime;
            }
        _Val ^= _Val >> 32;
        return (_Val);
    }
};

// Convert a GUID to a std::string.
// Return the guid string, or "" if any error.
std::string
StringFromGUID(
    LPCGUID guid
    );


#endif


#endif  // __GNUC__
#endif // __RTCPAL_VS_H__
