#pragma once

#ifndef __RTCPAL_LINUX_UTIL_H__
#define __RTCPAL_LINUX_UTIL_H__

#if defined(__linux)
#if defined(__cplusplus) 

#include <string>

// Get error string message for 'errno'
std::string
GetErrnoStr(
    int errnum
    );

std::string
GetFileBasename(
    const std::string & filepath
    );

std::wstring
GetFileBasename(
    const std::wstring & filepath
    );



RTCPAL_ERROR
RunDllMain(
    const char* filename,
    HANDLE dllHandle,
    DWORD reason);

void
RtcPalPrintBackTrace();

#endif // __cplusplus


#if defined(__cplusplus)
extern "C" {
#endif // __cplusplus

BOOL
IsRegularFileExist(
    const char* filepath
);

BOOL
IsDirectoryExist(
    const char* filepath
);

BOOL
IsFIFOExist(
    const char* filepath
);

// Determines whether a file or directory exists.
// Return TRUE if exists, return FALSE otherwise.
BOOL
PathFileExists(
    const char* filepath
);

BOOL
PAL_Random(
    BOOL bStrong,
    LPVOID lpBuffer,
    DWORD dwLength);

#if defined(__cplusplus)
}
#endif


#endif // __linux
#endif // __RTCPAL_LINUX_UTIL_H__
