#ifndef __RTCPAL_PRIVATE_ANDROID_H__
#define __RTCPAL_PRIVATE_ANDROID_H__

#define DUPLICATE_CLOSE_SOURCE 0x00000001 
#define DUPLICATE_SAME_ACCESS  0x00000002 
#define _POSIX_HOST_NAME_MAX 255

#ifdef _ENABLE_POISON_
#pragma GCC poison wcsnlen
#endif // _ENABLE_POISON_

#if !defined(__linux)
#include <android/log.h>
#endif

struct ifaddrs
{
    struct ifaddrs*  ifa_next; // Pointer to next items
    char*            ifa_name; // Interface name
    unsigned int     ifa_flags;
    struct sockaddr* ifa_addr;
    // The following three fields are customized 
    int              ifa_prefixlen;
    int              ifa_index;
    int              ifa_type;
};

DWORD
WINAPI
RtcPalGetAppFolderA(
    DWORD nBufferLength,
    LPSTR lpBuffer
    );

void
WINAPI
RtcPalSetAppFolderA(
    LPCSTR pszAppFolder
    );

void
WINAPI
RtcPalSetOSName(
    LPCWSTR pwszOSName
    );

#ifndef SHIP_BUILD
#define LOGV(x, ...) ((void)__android_log_print(ANDROID_LOG_VERBOSE, x, __VA_ARGS__))
#define LOGD(x, ...) ((void)__android_log_print(ANDROID_LOG_DEBUG, x, __VA_ARGS__))
#define LOGI(x, ...) ((void)__android_log_print(ANDROID_LOG_INFO, x, __VA_ARGS__))
#define LOGW(x, ...) ((void)__android_log_print(ANDROID_LOG_WARN, x, __VA_ARGS__))
#define LOGE(x, ...) ((void)__android_log_print(ANDROID_LOG_ERROR, x, __VA_ARGS__))
#define LOGF(x, ...) ((void)__android_log_print(ANDROID_LOG_FATAL, x, __VA_ARGS__))
#else
#define LOGV(x, ...)
#define LOGD(x, ...)
#define LOGI(x, ...)
#define LOGW(x, ...)
#define LOGE(x, ...)
#define LOGF(x, ...)
#endif

//#define MM_TRACK_INSTANCE_REFCOUNT

#endif // __RTCPAL_PRIVATE_ANDROID_H__
