#ifndef __RTCPAL_PRIVATE_IOS_H__
#define __RTCPAL_PRIVATE_IOS_H__

//use memcpy_s to prevent memcpy being expanded into stm/ldm
//or there will be alignment fault

EXTERN_C int __cdecl memcpy_s(void*, size_t, const void*, size_t);

#undef memcpy

#if __cplusplus
namespace rtcpal_private_ios {
#endif
    
static __inline void * memcpy_func(void *dst, const void *src, size_t len)
{
    memcpy_s(dst, len, src, len);
    return dst;
}
    
#if __cplusplus
  #define memcpy_custom rtcpal_private_ios::memcpy_func
} // namespace rtcpal_private_ios
#else
  #define memcpy_custom memcpy_func
#endif

#define memcpy(dst, src, n) memcpy_custom(dst, src, n)

EXTERN_C void ios_vprintf(const char * format, va_list args);

#endif // __RTCPAL_PRIVATE_IOS_H__
