
#ifdef __cplusplus
extern "C" {
#endif

typedef void * PSID;

static
RTCPAL_FORCEINLINE
RTCPAL_ERROR
RTCAPI
RtcPalGetSecurityInfo(
    __in HANDLE handle,
    __in uint32_t ObjectType,
    __in uint32_t SecurityInfoFlags,
    __out_opt PSID * ppsidOwner,
    __out_opt PSID * ppsidGroup,
    __out_opt PSID * ppsidDacl,
    __out_opt PSID * ppsidSacl,
    __out_opt PSECURITY_INFORMATION * ppSecurityDescriptor
    )
{
#pragma unused(handle, ObjectType, SecurityInfoFlags, ppsidOwner, ppsidGroup, ppsidDacl, ppsidSacl);
    *ppSecurityDescriptor = NULL;

    return NO_ERROR;
}

#undef GetSecurityInfo
#define GetSecurityInfo RtcPalGetSecurityInfo

#ifdef __cplusplus
};
#endif

#if defined(__cplusplus) && defined(__APPLE__)

//solve the strong type check of clang compiler
//the last parameter is defined as PSECURITY_DESCRIPTOR
static
RTCPAL_FORCEINLINE
RTCPAL_ERROR
RTCAPI
RtcPalGetSecurityInfo(
                      __in HANDLE handle,
                      __in uint32_t ObjectType,
                      __in uint32_t SecurityInfoFlags,
                      __out_opt PSID * ppsidOwner,
                      __out_opt PSID * ppsidGroup,
                      __out_opt PSID * ppsidDacl,
                      __out_opt PSID * ppsidSacl,
                      __out_opt PSECURITY_DESCRIPTOR * ppSecurityDescriptor
                      )
{    
    return RtcPalGetSecurityInfo(handle, ObjectType, SecurityInfoFlags, ppsidOwner, ppsidGroup, ppsidDacl, ppsidSacl,
                                 reinterpret_cast<PSECURITY_INFORMATION *>(ppSecurityDescriptor));
}

#endif
