#ifndef __ATLCOMVAR_H__
#define __ATLCOMVAR_H__


namespace ATL
{

/////////////////////////////////////////////////////////////////////////////
// CComVariant - originates from file atlcomcli.h on windows


#define ATL_VARIANT_TRUE VARIANT_BOOL( -1 )
#define ATL_VARIANT_FALSE VARIANT_BOOL( 0 )

template< typename T > 
class CVarTypeInfo
{
//	static const VARTYPE VT;  // VARTYPE corresponding to type T
//	static T VARIANT::* const pmField;  // Pointer-to-member of corresponding field in VARIANT struct
};

template<>
class CVarTypeInfo< char >
{
public:
	static const VARTYPE VT = VT_I1;
	static char VARIANT::* const pmField;
};

RTCPAL_SELECTANY char VARIANT::* const CVarTypeInfo< char >::pmField = &VARIANT::cVal;

template<>
class CVarTypeInfo< unsigned char >
{
public:
	static const VARTYPE VT = VT_UI1;
	static unsigned char VARIANT::* const pmField;
};

RTCPAL_SELECTANY unsigned char VARIANT::* const CVarTypeInfo< unsigned char >::pmField = &VARIANT::bVal;

template<>
class CVarTypeInfo< char* >
{
public:
	static const VARTYPE VT = VT_I1|VT_BYREF;
	static char* VARIANT::* const pmField;
};

RTCPAL_SELECTANY char* VARIANT::* const CVarTypeInfo< char* >::pmField = &VARIANT::pcVal;

template<>
class CVarTypeInfo< unsigned char* >
{
public:
	static const VARTYPE VT = VT_UI1|VT_BYREF;
	static unsigned char* VARIANT::* const pmField;
};

RTCPAL_SELECTANY unsigned char* VARIANT::* const CVarTypeInfo< unsigned char* >::pmField = &VARIANT::pbVal;

template<>
class CVarTypeInfo< short >
{
public:
	static const VARTYPE VT = VT_I2;
	static short VARIANT::* const pmField;
};

RTCPAL_SELECTANY short VARIANT::* const CVarTypeInfo< short >::pmField = &VARIANT::iVal;

template<>
class CVarTypeInfo< short* >
{
public:
	static const VARTYPE VT = VT_I2|VT_BYREF;
	static short* VARIANT::* const pmField;
};

RTCPAL_SELECTANY short* VARIANT::* const CVarTypeInfo< short* >::pmField = &VARIANT::piVal;

template<>
class CVarTypeInfo< unsigned short >
{
public:
	static const VARTYPE VT = VT_UI2;
	static unsigned short VARIANT::* const pmField;
};

RTCPAL_SELECTANY unsigned short VARIANT::* const CVarTypeInfo< unsigned short >::pmField = &VARIANT::uiVal;

#ifdef _NATIVE_WCHAR_T_DEFINED  // Only treat unsigned short* as VT_UI2|VT_BYREF if BSTR isn't the same as unsigned short*
template<>
class CVarTypeInfo< unsigned short* >
{
public:
	static const VARTYPE VT = VT_UI2|VT_BYREF;
	static unsigned short* VARIANT::* const pmField;
};

RTCPAL_SELECTANY unsigned short* VARIANT::* const CVarTypeInfo< unsigned short* >::pmField = &VARIANT::puiVal;
#endif  // _NATIVE_WCHAR_T_DEFINED

template<>
class CVarTypeInfo< int >
{
public:
	static const VARTYPE VT = VT_I4;
	static int VARIANT::* const pmField;
};

RTCPAL_SELECTANY int VARIANT::* const CVarTypeInfo< int >::pmField = &VARIANT::intVal;

template<>
class CVarTypeInfo< int* >
{
public:
	static const VARTYPE VT = VT_I4|VT_BYREF;
	static int* VARIANT::* const pmField;
};

RTCPAL_SELECTANY int* VARIANT::* const CVarTypeInfo< int* >::pmField = &VARIANT::pintVal;

template<>
class CVarTypeInfo< unsigned int >
{
public:
	static const VARTYPE VT = VT_UI4;
	static unsigned int VARIANT::* const pmField;
};

RTCPAL_SELECTANY unsigned int VARIANT::* const CVarTypeInfo< unsigned int >::pmField = &VARIANT::uintVal;

template<>
class CVarTypeInfo< unsigned int* >
{
public:
	static const VARTYPE VT = VT_UI4|VT_BYREF;
	static unsigned int* VARIANT::* const pmField;
};

RTCPAL_SELECTANY unsigned int* VARIANT::* const CVarTypeInfo< unsigned int* >::pmField = &VARIANT::puintVal;

template<>
class CVarTypeInfo< long >
{
public:
	static const VARTYPE VT = VT_I4;
	static long VARIANT::* const pmField;
};

RTCPAL_SELECTANY long VARIANT::* const CVarTypeInfo< long >::pmField = &VARIANT::lVal;

template<>
class CVarTypeInfo< long* >
{
public:
	static const VARTYPE VT = VT_I4|VT_BYREF;
	static long* VARIANT::* const pmField;
};

RTCPAL_SELECTANY long* VARIANT::* const CVarTypeInfo< long* >::pmField = &VARIANT::plVal;

template<>
class CVarTypeInfo< unsigned long >
{
public:
	static const VARTYPE VT = VT_UI4;
	static unsigned long VARIANT::* const pmField;
};

RTCPAL_SELECTANY unsigned long VARIANT::* const CVarTypeInfo< unsigned long >::pmField = &VARIANT::ulVal;

template<>
class CVarTypeInfo< unsigned long* >
{
public:
	static const VARTYPE VT = VT_UI4|VT_BYREF;
	static unsigned long* VARIANT::* const pmField;
};

RTCPAL_SELECTANY unsigned long* VARIANT::* const CVarTypeInfo< unsigned long* >::pmField = &VARIANT::pulVal;

template<>
class CVarTypeInfo< __int64 >
{
public:
	static const VARTYPE VT = VT_I8;
	static __int64 VARIANT::* const pmField;
};

RTCPAL_SELECTANY __int64 VARIANT::* const CVarTypeInfo< __int64 >::pmField = &VARIANT::llVal;

template<>
class CVarTypeInfo< __int64* >
{
public:
	static const VARTYPE VT = VT_I8|VT_BYREF;
	static __int64* VARIANT::* const pmField;
};

RTCPAL_SELECTANY __int64* VARIANT::* const CVarTypeInfo< __int64* >::pmField = &VARIANT::pllVal;

template<>
class CVarTypeInfo< unsigned __int64 >
{
public:
	static const VARTYPE VT = VT_UI8;
	static unsigned __int64 VARIANT::* const pmField;
};

RTCPAL_SELECTANY unsigned __int64 VARIANT::* const CVarTypeInfo< unsigned __int64 >::pmField = &VARIANT::ullVal;

template<>
class CVarTypeInfo< unsigned __int64* >
{
public:
	static const VARTYPE VT = VT_UI8|VT_BYREF;
	static unsigned __int64* VARIANT::* const pmField;
};

RTCPAL_SELECTANY unsigned __int64* VARIANT::* const CVarTypeInfo< unsigned __int64* >::pmField = &VARIANT::pullVal;

template<>
class CVarTypeInfo< float >
{
public:
	static const VARTYPE VT = VT_R4;
	static float VARIANT::* const pmField;
};

RTCPAL_SELECTANY float VARIANT::* const CVarTypeInfo< float >::pmField = &VARIANT::fltVal;

template<>
class CVarTypeInfo< float* >
{
public:
	static const VARTYPE VT = VT_R4|VT_BYREF;
	static float* VARIANT::* const pmField;
};

RTCPAL_SELECTANY float* VARIANT::* const CVarTypeInfo< float* >::pmField = &VARIANT::pfltVal;

template<>
class CVarTypeInfo< double >
{
public:
	static const VARTYPE VT = VT_R8;
	static double VARIANT::* const pmField;
};

RTCPAL_SELECTANY double VARIANT::* const CVarTypeInfo< double >::pmField = &VARIANT::dblVal;

template<>
class CVarTypeInfo< double* >
{
public:
	static const VARTYPE VT = VT_R8|VT_BYREF;
	static double* VARIANT::* const pmField;
};

RTCPAL_SELECTANY double* VARIANT::* const CVarTypeInfo< double* >::pmField = &VARIANT::pdblVal;

template<>

class CVarTypeInfo< VARIANT* >
{
public:
	static const VARTYPE VT = VT_VARIANT|VT_BYREF;
};

template<>
class CVarTypeInfo< BSTR >
{
public:
	static const VARTYPE VT = VT_BSTR;
	static BSTR VARIANT::* const pmField;
};

RTCPAL_SELECTANY BSTR VARIANT::* const CVarTypeInfo< BSTR >::pmField = &VARIANT::bstrVal;

template<>
class CVarTypeInfo< BSTR* >
{
public:
	static const VARTYPE VT = VT_BSTR|VT_BYREF;
	static BSTR* VARIANT::* const pmField;
};

RTCPAL_SELECTANY BSTR* VARIANT::* const CVarTypeInfo< BSTR* >::pmField = &VARIANT::pbstrVal;

template<>
class CVarTypeInfo< IUnknown* >
{
public:
	static const VARTYPE VT = VT_UNKNOWN;
	static IUnknown* VARIANT::* const pmField;
};

RTCPAL_SELECTANY IUnknown* VARIANT::* const CVarTypeInfo< IUnknown* >::pmField = &VARIANT::punkVal;

template<>
class CVarTypeInfo< IUnknown** >
{
public:
	static const VARTYPE VT = VT_UNKNOWN|VT_BYREF;
	static IUnknown** VARIANT::* const pmField;
};

RTCPAL_SELECTANY IUnknown** VARIANT::* const CVarTypeInfo< IUnknown** >::pmField = &VARIANT::ppunkVal;

template<>
class CVarTypeInfo< IDispatch* >
{
public:
	static const VARTYPE VT = VT_DISPATCH;
	static IDispatch* VARIANT::* const pmField;
};

RTCPAL_SELECTANY IDispatch* VARIANT::* const CVarTypeInfo< IDispatch* >::pmField = &VARIANT::pdispVal;

template<>
class CVarTypeInfo< IDispatch** >
{
public:
	static const VARTYPE VT = VT_DISPATCH|VT_BYREF;
	static IDispatch** VARIANT::* const pmField;
};

RTCPAL_SELECTANY IDispatch** VARIANT::* const CVarTypeInfo< IDispatch** >::pmField = &VARIANT::ppdispVal;

#if 0     // CY is LONGLONG and so this is a redefinition
template<>
class CVarTypeInfo< CY >
{
public:
	static const VARTYPE VT = VT_CY;
	static CY VARIANT::* const pmField;
};

RTCPAL_SELECTANY CY VARIANT::* const CVarTypeInfo< CY >::pmField = &VARIANT::cyVal;

template<>
class CVarTypeInfo< CY* >
{
public:
	static const VARTYPE VT = VT_CY|VT_BYREF;
	static CY* VARIANT::* const pmField;
};

RTCPAL_SELECTANY CY* VARIANT::* const CVarTypeInfo< CY* >::pmField = &VARIANT::pcyVal;
#endif

class CComVariant : 
	public tagVARIANT
{
// Constructors
public:
	CComVariant() RTCPAL_NOTHROW
	{
		// Make sure that variant data are initialized to 0
		memset(this, 0, sizeof(tagVARIANT));
		::VariantInit(this);
	}
	~CComVariant() RTCPAL_NOTHROW
	{
		HRESULT hr = Clear();
		ATLASSERT(SUCCEEDED(hr));
	}
	CComVariant(__in const VARIANT& varSrc) RTCPAL_NOTHROW
	{
		vt = VT_EMPTY;
		InternalCopy(&varSrc);
	}
	CComVariant(__in const CComVariant& varSrc) RTCPAL_NOTHROW
	{
		vt = VT_EMPTY;
		InternalCopy(&varSrc);
	}
	CComVariant(_In_z_ LPCOLESTR lpszSrc) RTCPAL_NOTHROW
	{
		vt = VT_EMPTY;
		*this = lpszSrc;
	}
	CComVariant(_In_z_ LPCSTR lpszSrc) RTCPAL_NOTHROW
	{
		vt = VT_EMPTY;
		*this = lpszSrc;
	}
	CComVariant(__in bool bSrc) RTCPAL_NOTHROW
	{
		vt = VT_BOOL;
		boolVal = bSrc ? ATL_VARIANT_TRUE : ATL_VARIANT_FALSE;
	}

	CComVariant(__in int nSrc, __in VARTYPE vtSrc = VT_I4) RTCPAL_NOTHROW
	{
		ATLASSERT(vtSrc == VT_I4 || vtSrc == VT_INT);
		if (vtSrc == VT_I4 || vtSrc == VT_INT)
		{
			vt = vtSrc;
			intVal = nSrc;
		}
		else
		{
			vt = VT_ERROR;
			scode = E_INVALIDARG;
			AtlThrow(E_INVALIDARG);
		}
	}

	CComVariant(__in BYTE nSrc) RTCPAL_NOTHROW
	{
		vt = VT_UI1;
		bVal = nSrc;
	}
	CComVariant(__in short nSrc) RTCPAL_NOTHROW
	{
		vt = VT_I2;
		iVal = nSrc;
	}
	CComVariant(__in long nSrc, __in VARTYPE vtSrc = VT_I4) RTCPAL_NOTHROW
	{
		ATLASSERT(vtSrc == VT_I4 || vtSrc == VT_ERROR);
		if (vtSrc == VT_I4 || vtSrc == VT_ERROR)
		{
			vt = vtSrc;
			lVal = nSrc;
		}
		else
		{
			vt = VT_ERROR;
			scode = E_INVALIDARG;
			AtlThrow(E_INVALIDARG);
		}
	}

	CComVariant(__in float fltSrc) RTCPAL_NOTHROW
	{
		vt = VT_R4;
		fltVal = fltSrc;
	}
	CComVariant(__in double dblSrc, __in VARTYPE vtSrc = VT_R8) RTCPAL_NOTHROW
	{
		ATLASSERT(vtSrc == VT_R8 || vtSrc == VT_DATE);
		if (vtSrc == VT_R8 || vtSrc == VT_DATE)
		{
			vt = vtSrc;
			dblVal = dblSrc;
		}
		else
		{
			vt = VT_ERROR;
			scode = E_INVALIDARG;
			AtlThrow(E_INVALIDARG);
		}
	}

//#if (_WIN32_WINNT >= 0x0501) || defined(_ATL_SUPPORT_VT_I8)
	CComVariant(__in LONGLONG nSrc) RTCPAL_NOTHROW
	{
		vt = VT_I8;
		llVal = nSrc;
	}
	CComVariant(__in ULONGLONG nSrc) RTCPAL_NOTHROW
	{
		vt = VT_UI8;
		ullVal = nSrc;
	}
//#endif
#if 0
	CComVariant(__in CY cySrc) RTCPAL_NOTHROW
	{
		vt = VT_CY;
		cyVal.Hi = cySrc.Hi;
		cyVal.Lo = cySrc.Lo;
	}
#endif
	CComVariant(__in_opt IDispatch* pSrc) RTCPAL_NOTHROW
	{
		vt = VT_DISPATCH;
		pdispVal = pSrc;
		// Need to AddRef as VariantClear will Release
		if (pdispVal != NULL)
			pdispVal->AddRef();
	}
	CComVariant(__in_opt IUnknown* pSrc) RTCPAL_NOTHROW
	{
		vt = VT_UNKNOWN;
		punkVal = pSrc;
		// Need to AddRef as VariantClear will Release
		if (punkVal != NULL)
			punkVal->AddRef();
	}
	CComVariant(__in char cSrc) RTCPAL_NOTHROW
	{
		vt = VT_I1;
		cVal = cSrc;
	}
	CComVariant(__in unsigned short nSrc) RTCPAL_NOTHROW
	{
		vt = VT_UI2;
		uiVal = nSrc;
	}
	CComVariant(__in unsigned long nSrc) RTCPAL_NOTHROW
	{
		vt = VT_UI4;
		ulVal = nSrc;
	}
	CComVariant(__in unsigned int nSrc, __in VARTYPE vtSrc = VT_UI4) RTCPAL_NOTHROW
	{
		ATLASSERT(vtSrc == VT_UI4 || vtSrc == VT_UINT);
		if (vtSrc == VT_UI4 || vtSrc == VT_UINT)
		{
			vt = vtSrc;
			uintVal= nSrc;
		}
		else
		{
			vt = VT_ERROR;
			scode = E_INVALIDARG;
			AtlThrow(E_INVALIDARG);
		}
	}
	CComVariant(__in const CComBSTR& bstrSrc) RTCPAL_NOTHROW
	{
		vt = VT_EMPTY;
		*this = bstrSrc;
	}
// Assignment Operators
public:
	CComVariant& operator=(__in const CComVariant& varSrc) RTCPAL_NOTHROW
	{
        if(this!=&varSrc)
        {
		    InternalCopy(&varSrc);
        }
		return *this;
	}
	CComVariant& operator=(__in const VARIANT& varSrc) RTCPAL_NOTHROW
	{
        if(static_cast<VARIANT *>(this)!=&varSrc)
        {
		    InternalCopy(&varSrc);
        }
		return *this;
	}

	CComVariant& operator=(__in const CComBSTR& bstrSrc) RTCPAL_NOTHROW
	{
		ClearThrow();

		vt = VT_BSTR;
		bstrVal = bstrSrc.Copy();

		if (bstrVal == NULL && bstrSrc.m_str != NULL)
		{
			vt = VT_ERROR;
			scode = E_OUTOFMEMORY;
			AtlThrow(E_OUTOFMEMORY);
		}
		
		return *this;
	}

	CComVariant& operator=(_In_z_ LPCOLESTR lpszSrc) RTCPAL_NOTHROW
	{
		if (vt != VT_BSTR || bstrVal != lpszSrc)
		{
			ClearThrow();

			vt = VT_BSTR;
			bstrVal = ::SysAllocString(lpszSrc);

			if (bstrVal == NULL && lpszSrc != NULL)
			{
				vt = VT_ERROR;
				scode = E_OUTOFMEMORY;
				AtlThrow(E_OUTOFMEMORY);
			}
		}
		return *this;
	}

	CComVariant& operator=(_In_z_ LPCSTR lpszSrc) RTCPAL_NOTHROW
	{
		USES_CONVERSION_EX;
		ClearThrow();

		vt = VT_BSTR;
		LPCSTR ptr = lpszSrc;
		bstrVal = ::SysAllocString(L"");
		if (bstrVal == NULL || lpszSrc == NULL)
		{
			vt = VT_ERROR;
			scode = E_OUTOFMEMORY;
			AtlThrow(E_OUTOFMEMORY);
		}
		while (*ptr != 0)
		{
			bstrVal += (WCHAR)*ptr;
			ptr++;
		}
		return *this;
	}

	CComVariant& operator=(__in bool bSrc) RTCPAL_NOTHROW
	{
		if (vt != VT_BOOL)
		{
			ClearThrow();
			vt = VT_BOOL;
		}
		boolVal = bSrc ? ATL_VARIANT_TRUE : ATL_VARIANT_FALSE;
		return *this;
	}

	CComVariant& operator=(__in int nSrc) RTCPAL_NOTHROW
	{
		if (vt != VT_I4)
		{
			ClearThrow();
			vt = VT_I4;
		}
		intVal = nSrc;

		return *this;
	}

	CComVariant& operator=(__in BYTE nSrc) RTCPAL_NOTHROW
	{
		if (vt != VT_UI1)
		{
			ClearThrow();
			vt = VT_UI1;
		}
		bVal = nSrc;
		return *this;
	}

	CComVariant& operator=(__in short nSrc) RTCPAL_NOTHROW
	{
		if (vt != VT_I2)
		{
			ClearThrow();
			vt = VT_I2;
		}
		iVal = nSrc;
		return *this;
	}

	CComVariant& operator=(__in long nSrc) RTCPAL_NOTHROW
	{
		if (vt != VT_I4)
		{
			ClearThrow();
			vt = VT_I4;
		}
		lVal = nSrc;
		return *this;
	}

	CComVariant& operator=(__in float fltSrc) RTCPAL_NOTHROW
	{
		if (vt != VT_R4)
		{
			ClearThrow();
			vt = VT_R4;
		}
		fltVal = fltSrc;
		return *this;
	}

	CComVariant& operator=(__in double dblSrc) RTCPAL_NOTHROW
	{
		if (vt != VT_R8)
		{
			ClearThrow();
			vt = VT_R8;
		}
		dblVal = dblSrc;
		return *this;
	}

#if 0
	CComVariant& operator=(__in CY cySrc) RTCPAL_NOTHROW
	{
		if (vt != VT_CY)
		{
			ClearThrow();
			vt = VT_CY;
		}
		cyVal.Hi = cySrc.Hi;
		cyVal.Lo = cySrc.Lo;
		return *this;
	}
#endif

	CComVariant& operator=(_Inout_opt_ IDispatch* pSrc) RTCPAL_NOTHROW
	{
		if (vt != VT_DISPATCH || pSrc != pdispVal)
		{
			ClearThrow();
			
			vt = VT_DISPATCH;
			pdispVal = pSrc;
			// Need to AddRef as VariantClear will Release
			if (pdispVal != NULL)
				pdispVal->AddRef();
		}
		return *this;
	}

	CComVariant& operator=(_Inout_opt_ IUnknown* pSrc) RTCPAL_NOTHROW
	{
		if (vt != VT_UNKNOWN || pSrc != punkVal)
		{
			ClearThrow();
			
			vt = VT_UNKNOWN;
			punkVal = pSrc;

			// Need to AddRef as VariantClear will Release
			if (punkVal != NULL)
				punkVal->AddRef();
		}
		return *this;
	}

	CComVariant& operator=(__in char cSrc) RTCPAL_NOTHROW
	{
		if (vt != VT_I1)
		{
			ClearThrow();
			vt = VT_I1;
		}
		cVal = cSrc;
		return *this;
	}

	CComVariant& operator=(__in unsigned short nSrc) RTCPAL_NOTHROW
	{
		if (vt != VT_UI2)
		{
			ClearThrow();
			vt = VT_UI2;
		}
		uiVal = nSrc;
		return *this;
	}

	CComVariant& operator=(__in unsigned long nSrc) RTCPAL_NOTHROW
	{
		if (vt != VT_UI4)
		{
			ClearThrow();
			vt = VT_UI4;
		}
		ulVal = nSrc;
		return *this;
	}

	CComVariant& operator=(__in unsigned int nSrc) RTCPAL_NOTHROW
	{
		if (vt != VT_UI4)
		{
			ClearThrow();
			vt = VT_UI4;
		}
		uintVal= nSrc;
		return *this;
	}

	CComVariant& operator=(__in BYTE* pbSrc) RTCPAL_NOTHROW
	{
		if (vt != (VT_UI1|VT_BYREF))
		{
			ClearThrow();
			vt = VT_UI1|VT_BYREF;
		}
		pbVal = pbSrc;
		return *this;
	}

	CComVariant& operator=(__in short* pnSrc) RTCPAL_NOTHROW
	{
		if (vt != (VT_I2|VT_BYREF))
		{
			ClearThrow();
			vt = VT_I2|VT_BYREF;
		}
		piVal = pnSrc;
		return *this;
	}

#ifdef _NATIVE_WCHAR_T_DEFINED
	CComVariant& operator=(__in USHORT* pnSrc) RTCPAL_NOTHROW
	{
		if (vt != (VT_UI2|VT_BYREF))
		{
			ClearThrow();
			vt = VT_UI2|VT_BYREF;
		}
		puiVal = pnSrc;
		return *this;
	}
#endif

	CComVariant& operator=(__in int* pnSrc) RTCPAL_NOTHROW
	{
		if (vt != (VT_I4|VT_BYREF))
		{
			ClearThrow();
			vt = VT_I4|VT_BYREF;
		}
		pintVal = pnSrc;
		return *this;
	}

	CComVariant& operator=(__in UINT* pnSrc) RTCPAL_NOTHROW
	{
		if (vt != (VT_UI4|VT_BYREF))
		{
			ClearThrow();
			vt = VT_UI4|VT_BYREF;
		}
		puintVal = pnSrc;
		return *this;
	}

	CComVariant& operator=(__in long* pnSrc) RTCPAL_NOTHROW
	{
		if (vt != (VT_I4|VT_BYREF))
		{
			ClearThrow();
			vt = VT_I4|VT_BYREF;
		}
		plVal = pnSrc;
		return *this;
	}

	CComVariant& operator=(__in ULONG* pnSrc) RTCPAL_NOTHROW
	{
		if (vt != (VT_UI4|VT_BYREF))
		{
			ClearThrow();
			vt = VT_UI4|VT_BYREF;
		}
		pulVal = pnSrc;
		return *this;
	}

#if (_WIN32_WINNT >= 0x0501) || defined(_ATL_SUPPORT_VT_I8)
	CComVariant& operator=(__in LONGLONG nSrc) RTCPAL_NOTHROW
	{
		if (vt != VT_I8)
		{
			ClearThrow();
			vt = VT_I8;
		}
		llVal = nSrc;

		return *this;
	}

	CComVariant& operator=(__in LONGLONG* pnSrc) RTCPAL_NOTHROW
	{
		if (vt != (VT_I8|VT_BYREF))
		{
			ClearThrow();
			vt = VT_I8|VT_BYREF;
		}
		pllVal = pnSrc;
		return *this;
	}

	CComVariant& operator=(__in ULONGLONG nSrc) RTCPAL_NOTHROW
	{
		if (vt != VT_UI8)
		{
			ClearThrow();
			vt = VT_UI8;
		}
		ullVal = nSrc;

		return *this;
	}

	CComVariant& operator=(__in ULONGLONG* pnSrc) RTCPAL_NOTHROW
	{
		if (vt != (VT_UI8|VT_BYREF))
		{
			ClearThrow();
			vt = VT_UI8|VT_BYREF;
		}
		pullVal = pnSrc;
		return *this;
	}
#endif

	CComVariant& operator=(__in float* pfSrc) RTCPAL_NOTHROW
	{
		if (vt != (VT_R4|VT_BYREF))
		{
			ClearThrow();
			vt = VT_R4|VT_BYREF;
		}
		pfltVal = pfSrc;
		return *this;
	}

	CComVariant& operator=(__in double* pfSrc) RTCPAL_NOTHROW
	{
		if (vt != (VT_R8|VT_BYREF))
		{
			ClearThrow();
			vt = VT_R8|VT_BYREF;
		}
		pdblVal = pfSrc;
		return *this;
	}

	CComVariant& operator=(__in const SAFEARRAY *pSrc) RTCPAL_NOTHROW
	{
		ATLASSERT(pSrc != NULL);	
		
		if (pSrc == NULL)
		{
			ClearThrow();
			vt = VT_ERROR;
			scode = E_INVALIDARG;
			AtlThrow(E_INVALIDARG);
		}
		
		return *this;
	}

// Comparison Operators
public:
	bool operator==(__in const VARIANT& varSrc) const RTCPAL_NOTHROW
	{
		// For backwards compatibility
		if (vt == VT_NULL && varSrc.vt == VT_NULL)
		{
			return true;
		}
		// Variants not equal if types don't match
		if (vt != varSrc.vt)
		{
			return false;
		}
		return VarCmp((VARIANT*)this, (VARIANT*)&varSrc, LOCALE_USER_DEFAULT, 0) == static_cast<HRESULT>(VARCMP_EQ);
	}

	bool operator!=(__in const VARIANT& varSrc) const RTCPAL_NOTHROW
	{
		return !operator==(varSrc);
	}

	bool operator<(__in const VARIANT& varSrc) const RTCPAL_NOTHROW
	{
		if (vt == VT_NULL && varSrc.vt == VT_NULL)
			return false;
		return VarCmp((VARIANT*)this, (VARIANT*)&varSrc, LOCALE_USER_DEFAULT, 0)== static_cast<HRESULT>(VARCMP_LT);
	}

	bool operator>(__in const VARIANT& varSrc) const RTCPAL_NOTHROW
	{
		if (vt == VT_NULL && varSrc.vt == VT_NULL)
			return false;
		return VarCmp((VARIANT*)this, (VARIANT*)&varSrc, LOCALE_USER_DEFAULT, 0)== static_cast<HRESULT>(VARCMP_GT);
	}

private:
	inline HRESULT VarCmp(
		__in LPVARIANT pvarLeft, 
		__in LPVARIANT pvarRight, 
		__in LCID lcid, 
		__in ULONG dwFlags) const RTCPAL_NOTHROW;

// Operations
public:
	HRESULT Clear()
	{ 
		return ::VariantClear(this); 
	}	
	HRESULT Copy(__in const VARIANT* pSrc)
	{ 
		return ::VariantCopy(this, const_cast<VARIANT*>(pSrc)); 
	}
	
//ATLPREFAST_SUPPRESS(6387)
	// copy VARIANT to BSTR
	HRESULT CopyTo(_Deref_out_z_ BSTR *pstrDest) const
	{
		ATLASSERT(pstrDest != NULL && vt == VT_BSTR);
		HRESULT hRes = E_POINTER;
		if (pstrDest != NULL && vt == VT_BSTR)
		{
			*pstrDest = ::SysAllocStringByteLen((char*)bstrVal, ::SysStringByteLen(bstrVal));
			if (*pstrDest == NULL)
				hRes = E_OUTOFMEMORY;
			else
				hRes = S_OK;
		}
		else if (vt != VT_BSTR)
			hRes = DISP_E_TYPEMISMATCH;
				
		return hRes;
	}
//ATLPREFAST_UNSUPPRESS()
	
	HRESULT Attach(__in VARIANT* pSrc)
	{
		if(pSrc == NULL)
			return E_INVALIDARG;			
		
		HRESULT hr = S_OK;
		if (this != pSrc)
		{
			// Clear out the variant
			hr = Clear();
			if (SUCCEEDED(hr))
			{
				// Copy the contents and give control to CComVariant
				Checked::memcpy_s(this, sizeof(CComVariant), pSrc, sizeof(VARIANT));
				pSrc->vt = VT_EMPTY;
				hr = S_OK;
			}
		}
		return hr;
	}

	HRESULT Detach(__out VARIANT* pDest)
	{
		ATLASSERT(pDest != NULL);
		if(pDest == NULL)
			return E_POINTER;
			
		// Clear out the variant
		HRESULT hr = ::VariantClear(pDest);
		if (SUCCEEDED(hr))
		{
			// Copy the contents and remove control from CComVariant
			Checked::memcpy_s(pDest, sizeof(VARIANT), this, sizeof(VARIANT));
			vt = VT_EMPTY;
			hr = S_OK;
		}
		return hr;
	}

	HRESULT ChangeType(__in VARTYPE vtNew, __in_opt const VARIANT* pSrc = NULL)
	{
		VARIANT* pVar = const_cast<VARIANT*>(pSrc);
		// Convert in place if pSrc is NULL
		if (pVar == NULL)
			pVar = this;
		// Do nothing if doing in place convert and vts not different
		return ::VariantChangeType(this, pVar, 0, vtNew);
	}

	template< typename T >
	void SetByRef(__in T* pT) //RTCPAL_NOTHROW
	{
		ClearThrow();
		vt = CVarTypeInfo< T* >::VT;
		byref = pT;
	}

	// Return the size in bytes of the current contents
	ULONG GetSize() const;
	HRESULT GetSizeMax(__out ULARGE_INTEGER* pcbSize) const;

// Implementation
private:
	void ClearThrow() RTCPAL_NOTHROW
	{
		HRESULT hr = Clear();
		ATLASSERT(SUCCEEDED(hr));
		if (FAILED(hr))
		{
			AtlThrow(hr);
		}
	}
	
public:
	_Check_return_ HRESULT InternalClear() RTCPAL_NOTHROW
	{
		HRESULT hr = Clear();		
		ATLASSERT(SUCCEEDED(hr));
		if (FAILED(hr))
		{
			vt = VT_ERROR;
			scode = hr;
			AtlThrow(hr);
		}
		return hr;
	}

	void InternalCopy(__in const VARIANT* pSrc) RTCPAL_NOTHROW
	{
		HRESULT hr = Copy(pSrc);
		if (FAILED(hr))
		{
			vt = VT_ERROR;
			scode = hr;
			AtlThrow(hr);
		}
	}
};


inline HRESULT CComVariant::GetSizeMax(__out ULARGE_INTEGER* pcbSize) const
{
	ATLASSERT(pcbSize != NULL);
	if (pcbSize == NULL)
	{
		return E_INVALIDARG;
	}
	
	HRESULT hr = S_OK;
	ULARGE_INTEGER nSize;
	nSize.QuadPart = sizeof(VARTYPE);	
	
	switch (vt)
	{
	case VT_UNKNOWN:
		break;
	case VT_UI1:
	case VT_I1:
		nSize.LowPart += sizeof(BYTE);
		break;
	case VT_I2:
	case VT_UI2:
	case VT_BOOL:
		nSize.LowPart += sizeof(short);
		break;
	case VT_I4:
	case VT_UI4:
	case VT_R4:
	case VT_INT:
	case VT_UINT:
	case VT_ERROR:
		nSize.LowPart += sizeof(long);
		break;
	case VT_I8:
	case VT_UI8:
		nSize.LowPart += sizeof(LONGLONG);
		break;
	case VT_R8:
#if 0
	case VT_CY:
#endif
	case VT_DATE:
		nSize.LowPart += sizeof(double);
		break;
	default:
		{
#if 0
			VARTYPE vtTmp = vt;
			BSTR bstr = NULL;
			CComVariant varBSTR;
			if (vtTmp != VT_BSTR)
			{
				hr = VariantChangeType(&varBSTR, const_cast<VARIANT*>((const VARIANT*)this), VARIANT_NOVALUEPROP, VT_BSTR);
				if (SUCCEEDED(hr))
				{
					bstr = varBSTR.bstrVal;
					vtTmp = VT_BSTR;
				}
			} 
			else
			{
				bstr = bstrVal;
			}

			if (vtTmp == VT_BSTR)
			{
				// Add the size of the length + string (in bytes) + NULL terminator.				
				nSize.QuadPart += rtcpal_wcslen(bstr) + sizeof(short) + 2*sizeof(long);
			}
#else
     ATLASSERT(0);
#endif
		}		
	}
	
	if (SUCCEEDED(hr))
	{
		pcbSize->QuadPart = nSize.QuadPart;
	}
	
	return hr;
}


/*
	Workaround for VarCmp function which does not compare VT_I1, VT_UI2, VT_UI4, VT_UI8 values
*/
inline HRESULT CComVariant::VarCmp(
	__in LPVARIANT pvarLeft, 
	__in LPVARIANT pvarRight, 
	__in LCID lcid, 
	__in ULONG dwFlags) const // RTCPAL_NOTHROW
{			
	switch(vt) 
	{
		case VT_I1:
			if (pvarLeft->cVal == pvarRight->cVal)
			{
				return VARCMP_EQ;
			}
			return pvarLeft->cVal > pvarRight->cVal ? VARCMP_GT : VARCMP_LT;			
		case VT_UI2:
			if (pvarLeft->uiVal == pvarRight->uiVal)
			{
				return VARCMP_EQ;
			}
			return pvarLeft->uiVal > pvarRight->uiVal ? VARCMP_GT : VARCMP_LT;

		case VT_UI4:
			if (pvarLeft->uintVal == pvarRight->uintVal) 
			{
				return VARCMP_EQ;
			}
			return pvarLeft->uintVal > pvarRight->uintVal ? VARCMP_GT : VARCMP_LT;				

		case VT_UI8:
			if (pvarLeft->ullVal == pvarRight->ullVal)
			{
				return VARCMP_EQ;
			}
			return pvarLeft->ullVal > pvarRight->ullVal ? VARCMP_GT : VARCMP_LT;

		default:
#if 0
			return ::VarCmp(pvarLeft, pvarRight, lcid, dwFlags);
#else
			ATLASSERT(0);
			return VARCMP_NULL;
#endif
	}
}

} // namespace ATL


#ifndef _ATL_NO_AUTOMATIC_NAMESPACE
using namespace ATL;
#endif //!_ATL_NO_AUTOMATIC_NAMESPACE

#endif // __ATLCOMVAR_H__
