
#ifndef __ATLCONV_H__
#define __ATLCONV_H__

#include <atldef.h>
#include <atlcore.h>
#include <atlexcept.h>
#include <atlalloc.h>

#define _acp_ex CP_UTF8

#ifndef _ATL_EX_CONVERSION_MACROS_ONLY
#ifndef _DEBUG
	#define USES_CONVERSION int _convert; (void)(_convert); UINT _acp = ATL::_AtlGetConversionACP() /*CP_THREAD_ACP*/; (void)(_acp); LPCWSTR _lpw; (void)(_lpw); LPCSTR _lpa; (void)(_lpa)
#else
	#define USES_CONVERSION int _convert = 0; (void)(_convert); UINT _acp = ATL::_AtlGetConversionACP() /*CP_THREAD_ACP*/; (void)(_acp); LPCWSTR _lpw = NULL; (void)(_lpw); LPCSTR _lpa = NULL; (void)(_lpa)
#endif
#endif	// _ATL_EX_CONVERSION_MACROS_ONLY

#ifndef _DEBUG
	#define USES_CONVERSION_EX int _convert_ex; (void)(_convert_ex); LPCWSTR _lpw_ex; (void)(_lpw_ex); LPCSTR _lpa_ex; (void)(_lpa_ex); USES_ATL_SAFE_ALLOCA
#else
	#define USES_CONVERSION_EX int _convert_ex = 0; (void)(_convert_ex); LPCWSTR _lpw_ex = NULL; (void)(_lpw_ex); LPCSTR _lpa_ex = NULL; (void)(_lpa_ex); USES_ATL_SAFE_ALLOCA
#endif

namespace ATL
{

inline __checkReturn BSTR A2WBSTR(__in_opt LPCSTR lp, int nLen = -1)
{
	if (lp == NULL || nLen == 0)
		return NULL;
	USES_CONVERSION_EX;
	BSTR str = NULL;
	int nConvertedLen = MultiByteToWideChar(_acp_ex, 0, lp,
		nLen, NULL, NULL);
	int nAllocLen = nConvertedLen;
	if (nLen == -1)
		nAllocLen -= 1;  // Don't allocate terminating '\0'
	str = ::SysAllocStringLen(NULL, nAllocLen);

	if (str != NULL)
	{
		int nResult;
		nResult = MultiByteToWideChar(_acp_ex, 0, lp, nLen, str, nConvertedLen);
		ATLASSERT(nResult == nConvertedLen);
		if(nResult != nConvertedLen)
		{
			SysFreeString(str);
			return NULL;
		}

	}
	return str;
}

} // namepsapce ATL

#if defined(ANDROID) || defined(__linux)

inline BOOL IsDBCSLeadByteEx(UINT CodePage, BYTE TestChar )
{
    return false;
}

inline WCHAR* AtlA2WHelper(WCHAR* pwszDst, const char* pszSrc, unsigned nCountChar) 
{
   mbstowcs(pwszDst, pszSrc, nCountChar);
   pwszDst[nCountChar-1] = L'\0';
   return pwszDst;
}

inline char* AtlW2AHelper(char* pszDst, const WCHAR* pwszSrc, unsigned nCountChar) 
{
   wcstombs(pszDst, pwszSrc, nCountChar);
   pszDst[nCountChar-1] = '\0';
   return pszDst;
}


inline HANDLE CreateFileW(
    LPCWSTR lpFileName,
    DWORD dwDesiredAccess,
    DWORD dwShareMode,
    LPSECURITY_ATTRIBUTES lpSecurityAttributes,
    DWORD dwCreationDisposition,
    DWORD dwFlagsAndAttributes,
    HANDLE hTemplateFile
    )
{
    size_t size = wcstombs(NULL, lpFileName, 0);

    char* pszFileName = new char[size + 2];
    if (size > 1) 
        size = wcstombs(pszFileName, lpFileName, size+1);
    else 
        size = 0;

    pszFileName[size] = '\0';

    HANDLE hFile = CreateFileA( pszFileName, dwDesiredAccess, dwShareMode, 
        lpSecurityAttributes, dwCreationDisposition, dwFlagsAndAttributes, hTemplateFile);

    delete [] pszFileName;
    return hFile;
}

#endif

#endif // __ATLCONV_H__
