
DEFINE_GUID(LIBID_QuartzTypeLib,0x56a868b0,0x0ad4,0x11ce,0xb0,0x3a,0x00,0x20,0xaf,0x0b,0xa7,0x70);
DEFINE_GUID(IID_IMediaControl,0x56a868b1,0x0ad4,0x11ce,0xb0,0x3a,0x00,0x20,0xaf,0x0b,0xa7,0x70);
DEFINE_GUID(IID_IMediaEvent,0x56a868b6,0x0ad4,0x11ce,0xb0,0x3a,0x00,0x20,0xaf,0x0b,0xa7,0x70);
DEFINE_GUID(IID_IMediaEventEx,0x56a868c0,0x0ad4,0x11ce,0xb0,0x3a,0x00,0x20,0xaf,0x0b,0xa7,0x70);
DEFINE_GUID(IID_IMediaPosition,0x56a868b2,0x0ad4,0x11ce,0xb0,0x3a,0x00,0x20,0xaf,0x0b,0xa7,0x70);
DEFINE_GUID(IID_IBasicAudio,0x56a868b3,0x0ad4,0x11ce,0xb0,0x3a,0x00,0x20,0xaf,0x0b,0xa7,0x70);
DEFINE_GUID(IID_IVideoWindow,0x56a868b4,0x0ad4,0x11ce,0xb0,0x3a,0x00,0x20,0xaf,0x0b,0xa7,0x70);
DEFINE_GUID(IID_IBasicVideo,0x56a868b5,0x0ad4,0x11ce,0xb0,0x3a,0x00,0x20,0xaf,0x0b,0xa7,0x70);
DEFINE_GUID(IID_IBasicVideo2,0x329bb360,0xf6ea,0x11d1,0x90,0x38,0x00,0xa0,0xc9,0x69,0x72,0x98);
DEFINE_GUID(IID_IDeferredCommand,0x56a868b8,0x0ad4,0x11ce,0xb0,0x3a,0x00,0x20,0xaf,0x0b,0xa7,0x70);

#ifndef __control_h__
#define __control_h__

typedef intptr_t OAEVENT;

typedef intptr_t OAHWND;

typedef int32_t OAFilterState;

class IMediaControl : public IDispatch
{
public:
    virtual HRESULT STDMETHODCALLTYPE Run( void) = 0;
    
    virtual HRESULT STDMETHODCALLTYPE Pause( void) = 0;
    
    virtual HRESULT STDMETHODCALLTYPE Stop( void) = 0;
    
    virtual HRESULT STDMETHODCALLTYPE GetState( 
        /* [in] */ LONG msTimeout,
        /* [out] */ __RPC__out OAFilterState *pfs) = 0;
    
    virtual HRESULT STDMETHODCALLTYPE RenderFile( 
        /* [in] */ __RPC__in BSTR strFilename) = 0;
    
    virtual HRESULT STDMETHODCALLTYPE AddSourceFilter( 
        /* [in] */ __RPC__in BSTR strFilename,
        /* [out] */ __RPC__deref_out_opt IDispatch **ppUnk) = 0;
    
    virtual /* [propget] */ HRESULT STDMETHODCALLTYPE get_FilterCollection( 
        /* [retval][out] */ __RPC__deref_out_opt IDispatch **ppUnk) = 0;
    
    virtual /* [propget] */ HRESULT STDMETHODCALLTYPE get_RegFilterCollection( 
        /* [retval][out] */ __RPC__deref_out_opt IDispatch **ppUnk) = 0;
    
    virtual HRESULT STDMETHODCALLTYPE StopWhenReady( void) = 0;
};

class IMediaEvent : public IDispatch
{
    virtual HRESULT STDMETHODCALLTYPE GetEventHandle( 
        /* [out] */ __RPC__out OAEVENT *hEvent) = 0;
    
    virtual HRESULT STDMETHODCALLTYPE GetEvent( 
        /* [out] */ __RPC__out LONG *lEventCode,
        /* [out] */ __RPC__out LONG_PTR *lParam1,
        /* [out] */ __RPC__out LONG_PTR *lParam2,
        /* [in] */ LONG msTimeout) = 0;
    
    virtual HRESULT STDMETHODCALLTYPE WaitForCompletion( 
        /* [in] */ LONG msTimeout,
        /* [out] */ __RPC__out LONG *pEvCode) = 0;
    
    virtual HRESULT STDMETHODCALLTYPE CancelDefaultHandling( 
        /* [in] */ LONG lEvCode) = 0;
    
    virtual HRESULT STDMETHODCALLTYPE RestoreDefaultHandling( 
        /* [in] */ LONG lEvCode) = 0;
    
    virtual HRESULT STDMETHODCALLTYPE FreeEventParams( 
        /* [in] */ LONG lEvCode,
        /* [in] */ LONG_PTR lParam1,
        /* [in] */ LONG_PTR lParam2) = 0;
};

class IMediaEventEx: public IMediaEvent
{
};

class IMediaPosition : public IDispatch
{
public:
    virtual /* [propget] */ HRESULT STDMETHODCALLTYPE get_Duration( 
        /* [retval][out] */ __RPC__out REFTIME *plength) = 0;
    
    virtual /* [propput] */ HRESULT STDMETHODCALLTYPE put_CurrentPosition( 
        /* [in] */ REFTIME llTime) = 0;
    
    virtual /* [propget] */ HRESULT STDMETHODCALLTYPE get_CurrentPosition( 
        /* [retval][out] */ __RPC__out REFTIME *pllTime) = 0;
    
    virtual /* [propget] */ HRESULT STDMETHODCALLTYPE get_StopTime( 
        /* [retval][out] */ __RPC__out REFTIME *pllTime) = 0;
    
    virtual /* [propput] */ HRESULT STDMETHODCALLTYPE put_StopTime( 
        /* [in] */ REFTIME llTime) = 0;
    
    virtual /* [propget] */ HRESULT STDMETHODCALLTYPE get_PrerollTime( 
        /* [retval][out] */ __RPC__out REFTIME *pllTime) = 0;
    
    virtual /* [propput] */ HRESULT STDMETHODCALLTYPE put_PrerollTime( 
        /* [in] */ REFTIME llTime) = 0;
    
    virtual /* [propput] */ HRESULT STDMETHODCALLTYPE put_Rate( 
        /* [in] */ double dRate) = 0;
    
    virtual /* [propget] */ HRESULT STDMETHODCALLTYPE get_Rate( 
        /* [retval][out] */ __RPC__out double *pdRate) = 0;
    
    virtual HRESULT STDMETHODCALLTYPE CanSeekForward( 
        /* [retval][out] */ __RPC__out LONG *pCanSeekForward) = 0;
    
    virtual HRESULT STDMETHODCALLTYPE CanSeekBackward( 
        /* [retval][out] */ __RPC__out LONG *pCanSeekBackward) = 0;
};

class IBasicAudio : public IDispatch
{
};

class IVideoWindow : public IDispatch
{
public:
    virtual /* [propput] */ HRESULT STDMETHODCALLTYPE put_Caption( 
        /* [in] */ __RPC__in BSTR strCaption) = 0;
    
    virtual /* [propget] */ HRESULT STDMETHODCALLTYPE get_Caption( 
        /* [retval][out] */ __RPC__deref_out_opt BSTR *strCaption) = 0;
    
    virtual /* [propput] */ HRESULT STDMETHODCALLTYPE put_WindowStyle( 
        /* [in] */ LONG WindowStyle) = 0;
    
    virtual /* [propget] */ HRESULT STDMETHODCALLTYPE get_WindowStyle( 
        /* [retval][out] */ __RPC__out LONG *WindowStyle) = 0;
    
    virtual /* [propput] */ HRESULT STDMETHODCALLTYPE put_WindowStyleEx( 
        /* [in] */ LONG WindowStyleEx) = 0;
    
    virtual /* [propget] */ HRESULT STDMETHODCALLTYPE get_WindowStyleEx( 
        /* [retval][out] */ __RPC__out LONG *WindowStyleEx) = 0;
    
    virtual /* [propput] */ HRESULT STDMETHODCALLTYPE put_AutoShow( 
        /* [in] */ LONG AutoShow) = 0;
    
    virtual /* [propget] */ HRESULT STDMETHODCALLTYPE get_AutoShow( 
        /* [retval][out] */ __RPC__out LONG *AutoShow) = 0;
    
    virtual /* [propput] */ HRESULT STDMETHODCALLTYPE put_WindowState( 
        /* [in] */ LONG WindowState) = 0;
    
    virtual /* [propget] */ HRESULT STDMETHODCALLTYPE get_WindowState( 
        /* [retval][out] */ __RPC__out LONG *WindowState) = 0;
    
    virtual /* [propput] */ HRESULT STDMETHODCALLTYPE put_BackgroundPalette( 
        /* [in] */ LONG BackgroundPalette) = 0;
    
    virtual /* [propget] */ HRESULT STDMETHODCALLTYPE get_BackgroundPalette( 
        /* [retval][out] */ __RPC__out LONG *pBackgroundPalette) = 0;
    
    virtual /* [propput] */ HRESULT STDMETHODCALLTYPE put_Visible( 
        /* [in] */ LONG Visible) = 0;
    
    virtual /* [propget] */ HRESULT STDMETHODCALLTYPE get_Visible( 
        /* [retval][out] */ __RPC__out LONG *pVisible) = 0;
    
    virtual /* [propput] */ HRESULT STDMETHODCALLTYPE put_Left( 
        /* [in] */ LONG Left) = 0;
    
    virtual /* [propget] */ HRESULT STDMETHODCALLTYPE get_Left( 
        /* [retval][out] */ __RPC__out LONG *pLeft) = 0;
    
    virtual /* [propput] */ HRESULT STDMETHODCALLTYPE put_Width( 
        /* [in] */ LONG Width) = 0;
    
    virtual /* [propget] */ HRESULT STDMETHODCALLTYPE get_Width( 
        /* [retval][out] */ __RPC__out LONG *pWidth) = 0;
    
    virtual /* [propput] */ HRESULT STDMETHODCALLTYPE put_Top( 
        /* [in] */ LONG Top) = 0;
    
    virtual /* [propget] */ HRESULT STDMETHODCALLTYPE get_Top( 
        /* [retval][out] */ __RPC__out LONG *pTop) = 0;
    
    virtual /* [propput] */ HRESULT STDMETHODCALLTYPE put_Height( 
        /* [in] */ LONG Height) = 0;
    
    virtual /* [propget] */ HRESULT STDMETHODCALLTYPE get_Height( 
        /* [retval][out] */ __RPC__out LONG *pHeight) = 0;
    
    virtual /* [propput] */ HRESULT STDMETHODCALLTYPE put_Owner( 
        /* [in] */ OAHWND Owner) = 0;
    
    virtual /* [propget] */ HRESULT STDMETHODCALLTYPE get_Owner( 
        /* [retval][out] */ __RPC__out OAHWND *Owner) = 0;
    
    virtual /* [propput] */ HRESULT STDMETHODCALLTYPE put_MessageDrain( 
        /* [in] */ OAHWND Drain) = 0;
    
    virtual /* [propget] */ HRESULT STDMETHODCALLTYPE get_MessageDrain( 
        /* [retval][out] */ __RPC__out OAHWND *Drain) = 0;
    
    virtual /* [propget] */ HRESULT STDMETHODCALLTYPE get_BorderColor( 
        /* [retval][out] */ __RPC__out LONG *Color) = 0;
    
    virtual /* [propput] */ HRESULT STDMETHODCALLTYPE put_BorderColor( 
        /* [in] */ LONG Color) = 0;
    
    virtual /* [propget] */ HRESULT STDMETHODCALLTYPE get_FullScreenMode( 
        /* [retval][out] */ __RPC__out LONG *FullScreenMode) = 0;
    
    virtual /* [propput] */ HRESULT STDMETHODCALLTYPE put_FullScreenMode( 
        /* [in] */ LONG FullScreenMode) = 0;
    
    virtual HRESULT STDMETHODCALLTYPE SetWindowForeground( 
        /* [in] */ LONG Focus) = 0;
    
    virtual HRESULT STDMETHODCALLTYPE NotifyOwnerMessage( 
        /* [in] */ OAHWND hwnd,
        /* [in] */ LONG uMsg,
        /* [in] */ LONG_PTR wParam,
        /* [in] */ LONG_PTR lParam) = 0;
    
    virtual HRESULT STDMETHODCALLTYPE SetWindowPosition( 
        /* [in] */ LONG Left,
        /* [in] */ LONG Top,
        /* [in] */ LONG Width,
        /* [in] */ LONG Height) = 0;
    
    virtual HRESULT STDMETHODCALLTYPE GetWindowPosition( 
        /* [out] */ __RPC__out LONG *pLeft,
        /* [out] */ __RPC__out LONG *pTop,
        /* [out] */ __RPC__out LONG *pWidth,
        /* [out] */ __RPC__out LONG *pHeight) = 0;
    
    virtual HRESULT STDMETHODCALLTYPE GetMinIdealImageSize( 
        /* [out] */ __RPC__out LONG *pWidth,
        /* [out] */ __RPC__out LONG *pHeight) = 0;
    
    virtual HRESULT STDMETHODCALLTYPE GetMaxIdealImageSize( 
        /* [out] */ __RPC__out LONG *pWidth,
        /* [out] */ __RPC__out LONG *pHeight) = 0;
    
    virtual HRESULT STDMETHODCALLTYPE GetRestorePosition( 
        /* [out] */ __RPC__out LONG *pLeft,
        /* [out] */ __RPC__out LONG *pTop,
        /* [out] */ __RPC__out LONG *pWidth,
        /* [out] */ __RPC__out LONG *pHeight) = 0;
    
    virtual HRESULT STDMETHODCALLTYPE HideCursor( 
        /* [in] */ LONG HideCursor) = 0;
    
    virtual HRESULT STDMETHODCALLTYPE IsCursorHidden( 
        /* [out] */ __RPC__out LONG *CursorHidden) = 0;
};
 
class IBasicVideo : public IDispatch
{
};

class IBasicVideo2 : public IBasicVideo
{
};

class IDeferredCommand : public IUnknown
{
};

class IQueueCommand : public IUnknown
{
};

#endif
