#ifndef __oaidl_h__
#define __oaidl_h__

#ifdef __cplusplus
extern "C" {
#endif

typedef struct tagSAFEARRAY SAFEARRAY;
typedef /* [wire_marshal] */ SAFEARRAY *LPSAFEARRAY;
typedef struct tagSAFEARRAYBOUND
    {
    ULONG cElements;
    LONG lLbound;
    } 	SAFEARRAYBOUND;

typedef struct tagSAFEARRAYBOUND *LPSAFEARRAYBOUND;

typedef uint16_t VARTYPE;

#ifdef __cplusplus
}
#endif

#include <oleauto.h>
#include <unknwn.h>

#ifdef __cplusplus

typedef LONG DISPID;
typedef DISPID MEMBERID;
typedef DWORD HREFTYPE;

EXTERN_C const IID IID_IDispatch;

typedef struct tagTYPEATTR TYPEATTR;
typedef struct tagTYPEATTR *LPTYPEATTR;

typedef /* [v1_enum] */ 
enum tagINVOKEKIND
    {	INVOKE_FUNC	= 1,
	INVOKE_PROPERTYGET	= 2,
	INVOKE_PROPERTYPUT	= 4,
	INVOKE_PROPERTYPUTREF	= 8
    } 	INVOKEKIND;

typedef struct tagFUNCDESC FUNCDESC;
typedef struct tagFUNCDESC *LPFUNCDESC;

typedef struct tagVARDESC VARDESC;
typedef struct tagVARDESC *LPVARDESC;

typedef 
enum tagTYPEFLAGS
    {	TYPEFLAG_FAPPOBJECT	= 0x1,
	TYPEFLAG_FCANCREATE	= 0x2,
	TYPEFLAG_FLICENSED	= 0x4,
	TYPEFLAG_FPREDECLID	= 0x8,
	TYPEFLAG_FHIDDEN	= 0x10,
	TYPEFLAG_FCONTROL	= 0x20,
	TYPEFLAG_FDUAL	= 0x40,
	TYPEFLAG_FNONEXTENSIBLE	= 0x80,
	TYPEFLAG_FOLEAUTOMATION	= 0x100,
	TYPEFLAG_FRESTRICTED	= 0x200,
	TYPEFLAG_FAGGREGATABLE	= 0x400,
	TYPEFLAG_FREPLACEABLE	= 0x800,
	TYPEFLAG_FDISPATCHABLE	= 0x1000,
	TYPEFLAG_FREVERSEBIND	= 0x2000,
	TYPEFLAG_FPROXY	= 0x4000
    } 	TYPEFLAGS;

typedef 
enum tagFUNCFLAGS
    {	FUNCFLAG_FRESTRICTED	= 0x1,
	FUNCFLAG_FSOURCE	= 0x2,
	FUNCFLAG_FBINDABLE	= 0x4,
	FUNCFLAG_FREQUESTEDIT	= 0x8,
	FUNCFLAG_FDISPLAYBIND	= 0x10,
	FUNCFLAG_FDEFAULTBIND	= 0x20,
	FUNCFLAG_FHIDDEN	= 0x40,
	FUNCFLAG_FUSESGETLASTERROR	= 0x80,
	FUNCFLAG_FDEFAULTCOLLELEM	= 0x100,
	FUNCFLAG_FUIDEFAULT	= 0x200,
	FUNCFLAG_FNONBROWSABLE	= 0x400,
	FUNCFLAG_FREPLACEABLE	= 0x800,
	FUNCFLAG_FIMMEDIATEBIND	= 0x1000
    } 	FUNCFLAGS;

typedef 
enum tagVARFLAGS
    {	VARFLAG_FREADONLY	= 0x1,
	VARFLAG_FSOURCE	= 0x2,
	VARFLAG_FBINDABLE	= 0x4,
	VARFLAG_FREQUESTEDIT	= 0x8,
	VARFLAG_FDISPLAYBIND	= 0x10,
	VARFLAG_FDEFAULTBIND	= 0x20,
	VARFLAG_FHIDDEN	= 0x40,
	VARFLAG_FRESTRICTED	= 0x80,
	VARFLAG_FDEFAULTCOLLELEM	= 0x100,
	VARFLAG_FUIDEFAULT	= 0x200,
	VARFLAG_FNONBROWSABLE	= 0x400,
	VARFLAG_FREPLACEABLE	= 0x800,
	VARFLAG_FIMMEDIATEBIND	= 0x1000
    } 	VARFLAGS;

typedef /* [wire_marshal] */ struct tagCLEANLOCALSTORAGE CLEANLOCALSTORAGE;

typedef struct tagCUSTDATAITEM CUSTDATAITEM;
typedef struct tagCUSTDATAITEM *LPCUSTDATAITEM;

typedef struct tagCUSTDATA CUSTDATA;
typedef struct tagCUSTDATA *LPCUSTDATA;

typedef struct tagVARIANT VARIANT;
typedef VARIANT *LPVARIANT;
typedef VARIANT VARIANTARG;
typedef VARIANT *LPVARIANTARG;

typedef struct tagDISPPARAMS
{
    VARIANTARG *rgvarg;
    DISPID *rgdispidNamedArgs;
    UINT cArgs;
    UINT cNamedArgs;
} DISPPARAMS;

typedef double DATE;
typedef LONG SCODE;
typedef int64_t CY;

typedef struct tagEXCEPINFO {
    WORD  wCode;
    WORD  wReserved;
    BSTR  bstrSource;
    BSTR  bstrDescription;
    BSTR  bstrHelpFile;
    DWORD dwHelpContext;
    PVOID pvReserved;
    HRESULT (__stdcall *pfnDeferredFillIn)(struct tagEXCEPINFO *);
    SCODE scode;
} EXCEPINFO, * LPEXCEPINFO;

typedef enum tagTYPEKIND
    {	TKIND_ENUM	= 0,
	TKIND_RECORD	= ( TKIND_ENUM + 1 ) ,
	TKIND_MODULE	= ( TKIND_RECORD + 1 ) ,
	TKIND_INTERFACE	= ( TKIND_MODULE + 1 ) ,
	TKIND_DISPATCH	= ( TKIND_INTERFACE + 1 ) ,
	TKIND_COCLASS	= ( TKIND_DISPATCH + 1 ) ,
	TKIND_ALIAS	= ( TKIND_COCLASS + 1 ) ,
	TKIND_UNION	= ( TKIND_ALIAS + 1 ) ,
	TKIND_MAX	= ( TKIND_UNION + 1 ) 
    } 	TYPEKIND;

typedef struct tagTLIBATTR TLIBATTR;
typedef struct tagTLIBATTR *LPTLIBATTR;

class ITypeLib;
class ITypeInfo;

class ITypeComp : public IUnknown
{
public:
};

class ITypeLib : public IUnknown
{
public:
    virtual /* [local] */ UINT STDMETHODCALLTYPE GetTypeInfoCount( void) = 0;
    
    virtual HRESULT STDMETHODCALLTYPE GetTypeInfo( 
        /* [in] */ UINT index,
        /* [out] */ __RPC__deref_out_opt ITypeInfo **ppTInfo) = 0;
    
    virtual HRESULT STDMETHODCALLTYPE GetTypeInfoType( 
        /* [in] */ UINT index,
        /* [out] */ __RPC__out TYPEKIND *pTKind) = 0;
    
    virtual HRESULT STDMETHODCALLTYPE GetTypeInfoOfGuid( 
        /* [in] */ __RPC__in REFGUID guid,
        /* [out] */ __RPC__deref_out_opt ITypeInfo **ppTinfo) = 0;
    
    virtual /* [local] */ HRESULT STDMETHODCALLTYPE GetLibAttr( 
        /* [out] */ TLIBATTR **ppTLibAttr) = 0;
    
    virtual HRESULT STDMETHODCALLTYPE GetTypeComp( 
        /* [out] */ __RPC__deref_out_opt ITypeComp **ppTComp) = 0;
    
    virtual /* [local] */ HRESULT STDMETHODCALLTYPE GetDocumentation( 
        /* [in] */ INT index,
        /* [out] */ BSTR *pBstrName,
        /* [out] */ BSTR *pBstrDocString,
        /* [out] */ DWORD *pdwHelpContext,
        /* [out] */ BSTR *pBstrHelpFile) = 0;
    
    virtual /* [local] */ HRESULT STDMETHODCALLTYPE IsName( 
        /* [out][in] */ LPOLESTR szNameBuf,
        /* [in] */ ULONG lHashVal,
        /* [out] */ RTCPAL_BOOL *pfName) = 0;
    
    virtual /* [local] */ HRESULT STDMETHODCALLTYPE FindName( 
        /* [out][in] */ LPOLESTR szNameBuf,
        /* [in] */ ULONG lHashVal,
        /* [length_is][size_is][out] */ ITypeInfo **ppTInfo,
        /* [length_is][size_is][out] */ MEMBERID *rgMemId,
        /* [out][in] */ USHORT *pcFound) = 0;
    
    virtual /* [local] */ void STDMETHODCALLTYPE ReleaseTLibAttr( 
        /* [in] */ TLIBATTR *pTLibAttr) = 0;
};

class ITypeInfo : public IUnknown
{
public:
    virtual /* [local] */ HRESULT STDMETHODCALLTYPE GetTypeAttr( 
        /* [out] */ TYPEATTR **ppTypeAttr) = 0;
    
    virtual HRESULT STDMETHODCALLTYPE GetTypeComp( 
        /* [out] */ __RPC__deref_out_opt ITypeComp **ppTComp) = 0;
    
    virtual /* [local] */ HRESULT STDMETHODCALLTYPE GetFuncDesc( 
        /* [in] */ UINT index,
        /* [out] */ FUNCDESC **ppFuncDesc) = 0;
    
    virtual /* [local] */ HRESULT STDMETHODCALLTYPE GetVarDesc( 
        /* [in] */ UINT index,
        /* [out] */ VARDESC **ppVarDesc) = 0;
    
    virtual /* [local] */ HRESULT STDMETHODCALLTYPE GetNames( 
        /* [in] */ MEMBERID memid,
        /* [length_is][size_is][out] */ BSTR *rgBstrNames,
        /* [in] */ UINT cMaxNames,
        /* [out] */ UINT *pcNames) = 0;
    
    virtual HRESULT STDMETHODCALLTYPE GetRefTypeOfImplType( 
        /* [in] */ UINT index,
        /* [out] */ __RPC__out HREFTYPE *pRefType) = 0;
    
    virtual HRESULT STDMETHODCALLTYPE GetImplTypeFlags( 
        /* [in] */ UINT index,
        /* [out] */ __RPC__out INT *pImplTypeFlags) = 0;
    
    virtual /* [local] */ HRESULT STDMETHODCALLTYPE GetIDsOfNames( 
        /* [size_is][in] */ LPOLESTR *rgszNames,
        /* [in] */ UINT cNames,
        /* [size_is][out] */ MEMBERID *pMemId) = 0;
    
    virtual /* [local] */ HRESULT STDMETHODCALLTYPE Invoke( 
        /* [in] */ PVOID pvInstance,
        /* [in] */ MEMBERID memid,
        /* [in] */ WORD wFlags,
        /* [out][in] */ DISPPARAMS *pDispParams,
        /* [out] */ VARIANT *pVarResult,
        /* [out] */ EXCEPINFO *pExcepInfo,
        /* [out] */ UINT *puArgErr) = 0;
    
    virtual /* [local] */ HRESULT STDMETHODCALLTYPE GetDocumentation( 
        /* [in] */ MEMBERID memid,
        /* [out] */ BSTR *pBstrName,
        /* [out] */ BSTR *pBstrDocString,
        /* [out] */ DWORD *pdwHelpContext,
        /* [out] */ BSTR *pBstrHelpFile) = 0;
    
    virtual /* [local] */ HRESULT STDMETHODCALLTYPE GetDllEntry( 
        /* [in] */ MEMBERID memid,
        /* [in] */ INVOKEKIND invKind,
        /* [out] */ BSTR *pBstrDllName,
        /* [out] */ BSTR *pBstrName,
        /* [out] */ WORD *pwOrdinal) = 0;
    
    virtual HRESULT STDMETHODCALLTYPE GetRefTypeInfo( 
        /* [in] */ HREFTYPE hRefType,
        /* [out] */ __RPC__deref_out_opt ITypeInfo **ppTInfo) = 0;
    
    virtual /* [local] */ HRESULT STDMETHODCALLTYPE AddressOfMember( 
        /* [in] */ MEMBERID memid,
        /* [in] */ INVOKEKIND invKind,
        /* [out] */ PVOID *ppv) = 0;
    
    virtual /* [local] */ HRESULT STDMETHODCALLTYPE CreateInstance( 
        /* [in] */ IUnknown *pUnkOuter,
        /* [in] */ REFIID riid,
        /* [iid_is][out] */ PVOID *ppvObj) = 0;
    
    virtual HRESULT STDMETHODCALLTYPE GetMops( 
        /* [in] */ MEMBERID memid,
        /* [out] */ __RPC__deref_out_opt BSTR *pBstrMops) = 0;
    
    virtual /* [local] */ HRESULT STDMETHODCALLTYPE GetContainingTypeLib( 
        /* [out] */ ITypeLib **ppTLib,
        /* [out] */ UINT *pIndex) = 0;
    
    virtual /* [local] */ void STDMETHODCALLTYPE ReleaseTypeAttr( 
        /* [in] */ TYPEATTR *pTypeAttr) = 0;
    
    virtual /* [local] */ void STDMETHODCALLTYPE ReleaseFuncDesc( 
        /* [in] */ FUNCDESC *pFuncDesc) = 0;
    
    virtual /* [local] */ void STDMETHODCALLTYPE ReleaseVarDesc( 
        /* [in] */ VARDESC *pVarDesc) = 0;

};

#define	DISPID_PROPERTYPUT	( -3 )

// class IRecordInfo;
class IDispatch;

typedef struct tagDEC {
    USHORT wReserved;
    union {
        struct {
            BYTE scale;
            BYTE sign;
        } DUMMYSTRUCTNAME;
        USHORT signscale;
    } DUMMYUNIONNAME;
    uint32_t Hi32;
    union {
        struct {
#if defined(RTCPAL_BIG_ENDIAN)
            uint32_t Mid32;
            uint32_t Lo32;
#else
            uint32_t Lo32;
            uint32_t Mid32;
#endif
        } DUMMYSTRUCTNAME2;
        uint64_t Lo64;
    } DUMMYUNIONNAME2;
} DECIMAL;

typedef int16_t VARIANT_BOOL;

/*
#define __VARIANT_NAME_1 n1
#define __VARIANT_NAME_2 n2
#define __VARIANT_NAME_3 n3
#define __VARIANT_NAME_4 brecVal
#define V_VT(X)         ((X)->n1.n2.vt)
#define V_UNION(X, Y)   ((X)->n1.n2.n3.Y)
// #define V_RECORDINFO(X) ((X)->n1.n2.n3.brecVal.pRecInfo)
#define V_RECORD(X)     ((X)->n1.n2.n3.brecVal.pvRecord)
#define V_DECIMAL(X)     ((X)->n1.decVal)
*/

#define __VARIANT_NAME_1
#define __VARIANT_NAME_2
#define __VARIANT_NAME_3
#define __VARIANT_NAME_4
#define V_VT(X)         ((X)->vt)
#define V_UNION(X, Y)   ((X)->Y)
// #define V_RECORDINFO(X) ((X)->pRecInfo)
#define V_RECORD(X)     ((X)->pvRecord)
#define V_DECIMAL(X)     ((X)->decVal)

#define V_ISBYREF(X)     (V_VT(X)&VT_BYREF)
#define V_ISARRAY(X)     (V_VT(X)&VT_ARRAY)
#define V_ISVECTOR(X)    (V_VT(X)&VT_VECTOR)
#define V_NONE(X)        V_I2(X)

#define V_UI1(X)         V_UNION(X, bVal)
#define V_UI1REF(X)      V_UNION(X, pbVal)
#define V_I2(X)          V_UNION(X, iVal)
#define V_I2REF(X)       V_UNION(X, piVal)
#define V_I4(X)          V_UNION(X, lVal)
#define V_I4REF(X)       V_UNION(X, plVal)
#define V_I8(X)          V_UNION(X, llVal)
#define V_I8REF(X)       V_UNION(X, pllVal)
#define V_R4(X)          V_UNION(X, fltVal)
#define V_R4REF(X)       V_UNION(X, pfltVal)
#define V_R8(X)          V_UNION(X, dblVal)
#define V_R8REF(X)       V_UNION(X, pdblVal)
#define V_I1(X)          V_UNION(X, cVal)
#define V_I1REF(X)       V_UNION(X, pcVal)
#define V_UI2(X)         V_UNION(X, uiVal)
#define V_UI2REF(X)      V_UNION(X, puiVal)
#define V_UI4(X)         V_UNION(X, ulVal)
#define V_UI4REF(X)      V_UNION(X, pulVal)
#define V_UI8(X)         V_UNION(X, ullVal)
#define V_UI8REF(X)      V_UNION(X, pullVal)
#define V_INT(X)         V_UNION(X, intVal)
#define V_INTREF(X)      V_UNION(X, pintVal)
#define V_UINT(X)        V_UNION(X, uintVal)
#define V_UINTREF(X)     V_UNION(X, puintVal)

#define V_CY(X)          V_UNION(X, cyVal)
#define V_CYREF(X)       V_UNION(X, pcyVal)
#define V_DATE(X)        V_UNION(X, date)
#define V_DATEREF(X)     V_UNION(X, pdate)
#define V_BSTR(X)        V_UNION(X, bstrVal)
#define V_BSTRREF(X)     V_UNION(X, pbstrVal)
#define V_DISPATCH(X)    V_UNION(X, pdispVal)
#define V_DISPATCHREF(X) V_UNION(X, ppdispVal)
#define V_ERROR(X)       V_UNION(X, scode)
#define V_ERRORREF(X)    V_UNION(X, pscode)
#define V_BOOL(X)        V_UNION(X, boolVal)
#define V_BOOLREF(X)     V_UNION(X, pboolVal)
#define V_UNKNOWN(X)     V_UNION(X, punkVal)
#define V_UNKNOWNREF(X)  V_UNION(X, ppunkVal)
#define V_VARIANTREF(X)  V_UNION(X, pvarVal)
#define V_ARRAY(X)       V_UNION(X, parray)
#define V_ARRAYREF(X)    V_UNION(X, pparray)
#define V_BYREF(X)       V_UNION(X, byref)


enum VARENUM
{	VT_EMPTY	= 0,
	VT_NULL	= 1,
	VT_I2	= 2,
	VT_I4	= 3,
	VT_R4	= 4,
	VT_R8	= 5,
	VT_CY	= 6,
	VT_DATE	= 7,
	VT_BSTR	= 8,
	VT_DISPATCH	= 9,
	VT_ERROR	= 10,
	VT_BOOL	= 11,
	VT_VARIANT	= 12,
	VT_UNKNOWN	= 13,
	VT_DECIMAL	= 14,
	VT_I1	= 16,
	VT_UI1	= 17,
	VT_UI2	= 18,
	VT_UI4	= 19,
	VT_I8	= 20,
	VT_UI8	= 21,
	VT_INT	= 22,
	VT_UINT	= 23,
	VT_VOID	= 24,
	VT_HRESULT	= 25,
	VT_PTR	= 26,
	VT_SAFEARRAY	= 27,
	VT_CARRAY	= 28,
	VT_USERDEFINED	= 29,
	VT_LPSTR	= 30,
	VT_LPWSTR	= 31,
	// VT_RECORD	= 36,
	VT_INT_PTR	= 37,
	VT_UINT_PTR	= 38,
	VT_FILETIME	= 64,
	VT_BLOB	= 65,
	VT_STREAM	= 66,
	VT_STORAGE	= 67,
	VT_STREAMED_OBJECT	= 68,
	VT_STORED_OBJECT	= 69,
	VT_BLOB_OBJECT	= 70,
	VT_CF	= 71,
	VT_CLSID	= 72,
	VT_VERSIONED_STREAM	= 73,
	VT_BSTR_BLOB	= 0xfff,
	VT_VECTOR	= 0x1000,
	VT_ARRAY	= 0x2000,
	VT_BYREF	= 0x4000,
	VT_RESERVED	= 0x8000,
	VT_ILLEGAL	= 0xffff,
	VT_ILLEGALMASKED	= 0xfff,
	VT_TYPEMASK	= 0xfff
};

typedef struct tagVARIANT VARIANT;

struct tagVARIANT {
    union {
        struct {
            VARTYPE vt;
            WORD wReserved1;
            WORD wReserved2;
            WORD wReserved3;
            union {
                LONGLONG llVal;
                LONG lVal;
                BYTE bVal;
                SHORT iVal;
                FLOAT fltVal;
                DOUBLE dblVal;
                VARIANT_BOOL boolVal;
                SCODE scode;
                CY cyVal;
                DATE date;
                BSTR bstrVal;
                IUnknown *punkVal;
                IDispatch *pdispVal;
                SAFEARRAY *parray;
                BYTE *pbVal;
                SHORT *piVal;
                LONG *plVal;
                LONGLONG *pllVal;
                FLOAT *pfltVal;
                DOUBLE *pdblVal;
                VARIANT_BOOL *pboolVal;
                SCODE *pscode;
                CY *pcyVal;
                DATE *pdate;
                BSTR *pbstrVal;
                IUnknown **ppunkVal;
                IDispatch **ppdispVal;
                SAFEARRAY **pparray;
                VARIANT *pvarVal;
                PVOID byref;
                CHAR cVal;
                USHORT uiVal;
                ULONG ulVal;
                ULONGLONG ullVal;
                INT intVal;
                UINT uintVal;
                DECIMAL *pdecVal;
                CHAR *pcVal;
                USHORT *puiVal;
                ULONG *pulVal;
                ULONGLONG *pullVal;
                INT *pintVal;
                UINT *puintVal;

                /*
                struct __tagBRECORD {
                    PVOID pvRecord;
                    IRecordInfo *pRecInfo;
                } 	__VARIANT_NAME_4;
                */
            } __VARIANT_NAME_3;
        } 	__VARIANT_NAME_2;

        DECIMAL decVal;
    } 	__VARIANT_NAME_1;
};

class IDispatch : public IUnknown
{
public:
    virtual HRESULT STDMETHODCALLTYPE GetTypeInfoCount( 
        /* [out] */ __RPC__out UINT *pctinfo) = 0;
    
    virtual HRESULT STDMETHODCALLTYPE GetTypeInfo( 
        /* [in] */ UINT iTInfo,
        /* [in] */ LCID lcid,
        /* [out] */ __RPC__deref_out_opt ITypeInfo **ppTInfo) = 0;
    
    virtual HRESULT STDMETHODCALLTYPE GetIDsOfNames( 
        /* [in] */ __RPC__in REFIID riid,
        /* [size_is][in] */ __RPC__in_ecount_full(cNames) LPOLESTR *rgszNames,
        /* [range][in] */ UINT cNames,
        /* [in] */ LCID lcid,
        /* [size_is][out] */ __RPC__out_ecount_full(cNames) DISPID *rgDispId) = 0;
    
    virtual /* [local] */ HRESULT STDMETHODCALLTYPE Invoke( 
        /* [in] */ DISPID dispIdMember,
        /* [in] */ REFIID riid,
        /* [in] */ LCID lcid,
        /* [in] */ WORD wFlags,
        /* [out][in] */ DISPPARAMS *pDispParams,
        /* [out] */ VARIANT *pVarResult,
        /* [out] */ EXCEPINFO *pExcepInfo,
        /* [out] */ UINT *puArgErr) = 0;
};

class IBindCtx;
typedef __RPC_unique_pointer IBindCtx * LPBC;

EXTERN_C void VariantInit(__out VARIANTARG * pvarg);
EXTERN_C HRESULT VariantCopy(__inout VARIANTARG * pvarg, const VARIANTARG * pvsrc);
EXTERN_C HRESULT VariantChangeType(__inout VARIANTARG * pvargDest,
               __in const VARIANTARG * pvarSrc, __in USHORT wFlags, __in VARTYPE vt);
EXTERN_C HRESULT VariantClear(__inout VARIANTARG * pvarg);

struct IEnumVARIANT : public IUnknown
{
public:
    virtual /* [local] */ HRESULT STDMETHODCALLTYPE Next( 
        /* [in] */ ULONG celt,
        /* [length_is][size_is][out] */ VARIANT *rgVar,
        /* [out] */ ULONG *pCeltFetched) = 0;
    
    virtual HRESULT STDMETHODCALLTYPE Skip( 
        /* [in] */ ULONG celt) = 0;
    
    virtual HRESULT STDMETHODCALLTYPE Reset( void) = 0;
    
    virtual HRESULT STDMETHODCALLTYPE Clone( 
        /* [out] */ __RPC__deref_out_opt IEnumVARIANT **ppEnum) = 0;
    
};

class IErrorLog : public IUnknown
{
public:
};

EXTERN_C const IID IID_IPropertyBag;
class IPropertyBag : public IUnknown
{
public:
    virtual /* [local] */ HRESULT STDMETHODCALLTYPE Read( 
        /* [in] */ LPCOLESTR pszPropName,
        /* [out][in] */ VARIANT *pVar,
        /* [unique][in] */ IErrorLog *pErrorLog) = 0;
    
    virtual HRESULT STDMETHODCALLTYPE Write( 
        /* [in] */ __RPC__in LPCOLESTR pszPropName,
        /* [in] */ __RPC__in VARIANT *pVar) = 0;
    
};

#endif  // __cplusplus

#endif // __oaidl_h__

