#if !defined( _OBJBASE_H_ )
#define _OBJBASE_H_

#ifndef __OBJC__
    // for COM API definition
    #ifdef interface
    #error "interface symbol name conflict"
    #endif
    #define interface struct
#endif

#ifdef __cplusplus
extern "C" {
#endif

typedef struct tagBSTRBLOB BSTRBLOB;
typedef struct tagBSTRBLOB *LPBSTRBLOB;

#define DECLSPEC_UUID(x)

#ifdef __cplusplus
}
#endif

#include <oaidl.h>
#include <propidl.h>

#ifdef __cplusplus
extern "C" {
#endif

typedef enum tagCOINIT
{
  COINIT_APARTMENTTHREADED  = 0x2,      // Apartment model
  COINIT_MULTITHREADED      = 0x0,      // OLE calls objects on any thread.
  COINIT_DISABLE_OLE1DDE    = 0x4,      // Don't use DDE for Ole1 support.
  COINIT_SPEED_OVER_MEMORY  = 0x8,      // Trade memory for speed.
} COINIT;


__checkReturn HRESULT CoInitialize(__in_opt LPVOID pvReserved);
__checkReturn WINOLEAPI  CoInitializeEx(__in_opt LPVOID pvReserved, __in DWORD dwCoInit);
void CoUninitialize(void);
void CoFreeUnusedLibraries(void);

__checkReturn int StringFromGUID2(__in REFGUID rguid, __in_ecount(cchMax) LPOLESTR lpsz, __in int cchMax);
__checkReturn HRESULT CoCreateGuid(__out GUID FAR *pguid);
__checkReturn HRESULT CLSIDFromString(__in LPCOLESTR lpsz, __out LPCLSID pclsid);

HRESULT StringFromIID(GUID rclsid, LPOLESTR FAR * lplpsz);
HRESULT IIDFromString(LPCWSTR lpsz, GUID* lpiid);

// convert a GUID to a string.
// The buf must be pre-allocated before calling this function.
//
// Return the numbers of bytes stored in the string, including the null terminator.
// If any error, return 0.
int StringFromGUID(LPCGUID guid, char* buf, int buflen);


__bcount_opt(cb) __allocator LPVOID CoTaskMemAlloc(__in SIZE_T cb);
__bcount_opt(cb) __allocator LPVOID CoTaskMemRealloc(__in_opt LPVOID pv, __in SIZE_T cb);
void CoTaskMemFree(__in_opt LPVOID pv);

#define CLSCTX_ALL  0
#define CLSCTX_INPROC_SERVER    0

__checkReturn WINOLEAPI
CoCreateInstance(
    __in     REFCLSID rclsid, 
    __in_opt LPUNKNOWN pUnkOuter,
    __in     DWORD dwClsContext, 
    __in     REFIID riid, 
    __deref_out LPVOID FAR* ppv
    );

__checkReturn WINOLEAPI CreateBindCtx(__in DWORD reserved, __deref_out LPBC FAR* ppbc);
__checkReturn WINOLEAPI MkParseDisplayName(__in LPBC pbc, __in LPCOLESTR szUserName,
                __out ULONG FAR * pchEaten, __deref_out LPMONIKER FAR * ppmk);
__checkReturn WINOLEAPI  GetRunningObjectTable( __in DWORD reserved, __deref_out LPRUNNINGOBJECTTABLE FAR* pprot);
__checkReturn WINOLEAPI  CreateItemMoniker(__in LPCOLESTR lpszDelim, __in LPCOLESTR lpszItem,
                          __deref_out LPMONIKER FAR* ppmk);

typedef HRESULT (STDAPICALLTYPE * LPFNGETCLASSOBJECT) (REFCLSID, REFIID, LPVOID *);

#ifdef __cplusplus
}
#endif

#ifdef __cplusplus
#define PURE                    = 0
#define THIS_
#define THIS                    void
#define DECLARE_INTERFACE(iface) struct iface
#define DECLARE_INTERFACE_(iface, baseiface)            struct iface : public baseiface

#define STDMETHOD(method)        virtual HRESULT STDMETHODCALLTYPE method
#define STDMETHOD_(type,method)  virtual type STDMETHODCALLTYPE method
#define STDMETHODV(method)       virtual HRESULT STDMETHODVCALLTYPE method
#define STDMETHODV_(type,method) virtual type STDMETHODVCALLTYPE method
#endif

#define STGM_READ               0x00000000L
#define STGM_WRITE              0x00000001L
#define STGM_READWRITE          0x00000002L

#define STGM_SHARE_DENY_NONE    0x00000040L
#define STGM_SHARE_DENY_READ    0x00000030L
#define STGM_SHARE_DENY_WRITE   0x00000020L
#define STGM_SHARE_EXCLUSIVE    0x00000010L

#define STGM_PRIORITY           0x00040000L
#define STGM_DELETEONRELEASE    0x04000000L
#if (WINVER >= 400)
#define STGM_NOSCRATCH          0x00100000L
#endif /* WINVER */

#define STGM_CREATE             0x00001000L
#define STGM_CONVERT            0x00020000L
#define STGM_FAILIFTHERE        0x00000000L

#define STGM_NOSNAPSHOT         0x00200000L
#if (_WIN32_WINNT >= 0x0500)
#define STGM_DIRECT_SWMR        0x00400000L
#endif
typedef struct IRpcStubBuffer     IRpcStubBuffer;
typedef struct IRpcChannelBuffer  IRpcChannelBuffer;
#endif     // __OBJBASE_H__

