
#ifndef __objidl_h__
#define __objidl_h__

#include <oaidl.h>

struct IStorage;

EXTERN_C const IID IID_IPersist;
class IPersist : public IUnknown
{
public:
    virtual HRESULT STDMETHODCALLTYPE GetClassID( 
        /* [out] */ __RPC__out CLSID *pClassID) = 0;
    
};

class ISequentialStream : public IUnknown
{
public:
};

class IStream : public ISequentialStream
{
public:
    virtual /* [local] */ HRESULT STDMETHODCALLTYPE Read( 
        /* [length_is][size_is][out] */ void *pv,
        /* [in] */ ULONG cb,
        /* [out] */ ULONG *pcbRead) = 0;
    
    virtual /* [local] */ HRESULT STDMETHODCALLTYPE Write( 
        /* [size_is][in] */ const void *pv,
        /* [in] */ ULONG cb,
        /* [out] */ ULONG *pcbWritten) = 0;
};

EXTERN_C const IID IID_IPersistStream;
class IPersistStream : public IPersist
{
public:
    virtual HRESULT STDMETHODCALLTYPE IsDirty( void) = 0;
    
    virtual HRESULT STDMETHODCALLTYPE Load( 
        /* [unique][in] */ __RPC__in_opt IStream *pStm) = 0;
    
    virtual HRESULT STDMETHODCALLTYPE Save( 
        /* [unique][in] */ __RPC__in_opt IStream *pStm,
        /* [in] */ RTCPAL_BOOL fClearDirty) = 0;
    
    virtual HRESULT STDMETHODCALLTYPE GetSizeMax( 
        /* [out] */ __RPC__out ULARGE_INTEGER *pcbSize) = 0;
    
};

typedef struct tagBIND_OPTS BIND_OPTS;
typedef struct tagBIND_OPTS *LPBIND_OPTS;

class IEnumString;
class IRunningObjectTable;

class IBindCtx : public IUnknown
{
public:
    virtual HRESULT STDMETHODCALLTYPE RegisterObjectBound( 
        /* [unique][in] */ __RPC__in_opt IUnknown *punk) = 0;
    
    virtual HRESULT STDMETHODCALLTYPE RevokeObjectBound( 
        /* [unique][in] */ __RPC__in_opt IUnknown *punk) = 0;
    
    virtual HRESULT STDMETHODCALLTYPE ReleaseBoundObjects( void) = 0;
    
    virtual /* [local] */ HRESULT STDMETHODCALLTYPE SetBindOptions( 
        /* [in] */ BIND_OPTS *pbindopts) = 0;
    
    virtual /* [local] */ HRESULT STDMETHODCALLTYPE GetBindOptions( 
        /* [out][in] */ BIND_OPTS *pbindopts) = 0;
    
    virtual HRESULT STDMETHODCALLTYPE GetRunningObjectTable( 
        /* [out] */ __RPC__deref_out_opt IRunningObjectTable **pprot) = 0;
    
    virtual HRESULT STDMETHODCALLTYPE RegisterObjectParam( 
        /* [in] */ __RPC__in LPOLESTR pszKey,
        /* [unique][in] */ __RPC__in_opt IUnknown *punk) = 0;
    
    virtual HRESULT STDMETHODCALLTYPE GetObjectParam( 
        /* [in] */ __RPC__in LPOLESTR pszKey,
        /* [out] */ __RPC__deref_out_opt IUnknown **ppunk) = 0;
    
    virtual HRESULT STDMETHODCALLTYPE EnumObjectParam( 
        /* [out] */ __RPC__deref_out_opt IEnumString **ppenum) = 0;
    
    virtual HRESULT STDMETHODCALLTYPE RevokeObjectParam( 
        /* [in] */ __RPC__in LPOLESTR pszKey) = 0;
    
};

class IEnumMoniker;
class IMoniker : public IPersistStream
{
public:
    virtual /* [local] */ HRESULT STDMETHODCALLTYPE BindToObject( 
        /* [unique][in] */ IBindCtx *pbc,
        /* [unique][in] */ IMoniker *pmkToLeft,
        /* [in] */ REFIID riidResult,
        /* [iid_is][out] */ void **ppvResult) = 0;
    
    virtual /* [local] */ HRESULT STDMETHODCALLTYPE BindToStorage( 
        /* [unique][in] */ IBindCtx *pbc,
        /* [unique][in] */ IMoniker *pmkToLeft,
        /* [in] */ REFIID riid,
        /* [iid_is][out] */ void **ppvObj) = 0;
    
    virtual HRESULT STDMETHODCALLTYPE Reduce( 
        /* [unique][in] */ __RPC__in_opt IBindCtx *pbc,
        /* [in] */ DWORD dwReduceHowFar,
        /* [unique][out][in] */ __RPC__deref_opt_inout_opt IMoniker **ppmkToLeft,
        /* [out] */ __RPC__deref_out_opt IMoniker **ppmkReduced) = 0;
    
    virtual HRESULT STDMETHODCALLTYPE ComposeWith( 
        /* [unique][in] */ __RPC__in_opt IMoniker *pmkRight,
        /* [in] */ RTCPAL_BOOL fOnlyIfNotGeneric,
        /* [out] */ __RPC__deref_out_opt IMoniker **ppmkComposite) = 0;
    
    virtual HRESULT STDMETHODCALLTYPE Enum( 
        /* [in] */ RTCPAL_BOOL fForward,
        /* [out] */ __RPC__deref_out_opt IEnumMoniker **ppenumMoniker) = 0;
    
    virtual HRESULT STDMETHODCALLTYPE IsEqual( 
        /* [unique][in] */ __RPC__in_opt IMoniker *pmkOtherMoniker) = 0;
    
    virtual HRESULT STDMETHODCALLTYPE Hash( 
        /* [out] */ __RPC__out DWORD *pdwHash) = 0;
    
    virtual HRESULT STDMETHODCALLTYPE IsRunning( 
        /* [unique][in] */ __RPC__in_opt IBindCtx *pbc,
        /* [unique][in] */ __RPC__in_opt IMoniker *pmkToLeft,
        /* [unique][in] */ __RPC__in_opt IMoniker *pmkNewlyRunning) = 0;
    
    virtual HRESULT STDMETHODCALLTYPE GetTimeOfLastChange( 
        /* [unique][in] */ __RPC__in_opt IBindCtx *pbc,
        /* [unique][in] */ __RPC__in_opt IMoniker *pmkToLeft,
        /* [out] */ __RPC__out FILETIME *pFileTime) = 0;
    
    virtual HRESULT STDMETHODCALLTYPE Inverse( 
        /* [out] */ __RPC__deref_out_opt IMoniker **ppmk) = 0;
    
    virtual HRESULT STDMETHODCALLTYPE CommonPrefixWith( 
        /* [unique][in] */ __RPC__in_opt IMoniker *pmkOther,
        /* [out] */ __RPC__deref_out_opt IMoniker **ppmkPrefix) = 0;
    
    virtual HRESULT STDMETHODCALLTYPE RelativePathTo( 
        /* [unique][in] */ __RPC__in_opt IMoniker *pmkOther,
        /* [out] */ __RPC__deref_out_opt IMoniker **ppmkRelPath) = 0;
    
    virtual HRESULT STDMETHODCALLTYPE GetDisplayName( 
        /* [unique][in] */ __RPC__in_opt IBindCtx *pbc,
        /* [unique][in] */ __RPC__in_opt IMoniker *pmkToLeft,
        /* [out] */ __RPC__deref_out_opt LPOLESTR *ppszDisplayName) = 0;
    
    virtual HRESULT STDMETHODCALLTYPE ParseDisplayName( 
        /* [unique][in] */ __RPC__in_opt IBindCtx *pbc,
        /* [unique][in] */ __RPC__in_opt IMoniker *pmkToLeft,
        /* [in] */ __RPC__in LPOLESTR pszDisplayName,
        /* [out] */ __RPC__out ULONG *pchEaten,
        /* [out] */ __RPC__deref_out_opt IMoniker **ppmkOut) = 0;
    
    virtual HRESULT STDMETHODCALLTYPE IsSystemMoniker( 
        /* [out] */ __RPC__out DWORD *pdwMksys) = 0;
};

class IRunningObjectTable : public IUnknown
{
public:
    virtual HRESULT STDMETHODCALLTYPE Register( 
        /* [in] */ DWORD grfFlags,
        /* [unique][in] */ __RPC__in_opt IUnknown *punkObject,
        /* [unique][in] */ __RPC__in_opt IMoniker *pmkObjectName,
        /* [out] */ __RPC__out DWORD *pdwRegister) = 0;
    
    virtual HRESULT STDMETHODCALLTYPE Revoke( 
        /* [in] */ DWORD dwRegister) = 0;
    
    virtual HRESULT STDMETHODCALLTYPE IsRunning( 
        /* [unique][in] */ __RPC__in_opt IMoniker *pmkObjectName) = 0;
    
    virtual HRESULT STDMETHODCALLTYPE GetObject( 
        /* [unique][in] */ __RPC__in_opt IMoniker *pmkObjectName,
        /* [out] */ __RPC__deref_out_opt IUnknown **ppunkObject) = 0;
    
    virtual HRESULT STDMETHODCALLTYPE NoteChangeTime( 
        /* [in] */ DWORD dwRegister,
        /* [in] */ __RPC__in FILETIME *pfiletime) = 0;
    
    virtual HRESULT STDMETHODCALLTYPE GetTimeOfLastChange( 
        /* [unique][in] */ __RPC__in_opt IMoniker *pmkObjectName,
        /* [out] */ __RPC__out FILETIME *pfiletime) = 0;
    
    virtual HRESULT STDMETHODCALLTYPE EnumRunning( 
        /* [out] */ __RPC__deref_out_opt IEnumMoniker **ppenumMoniker) = 0;
};

class IEnumMoniker : public IUnknown
{
public:
    virtual /* [local] */ HRESULT STDMETHODCALLTYPE Next( 
        /* [in] */ ULONG celt,
        /* [length_is][size_is][out] */ IMoniker **rgelt,
        /* [out] */ ULONG *pceltFetched) = 0;
    
    virtual HRESULT STDMETHODCALLTYPE Skip( 
        /* [in] */ ULONG celt) = 0;
    
    virtual HRESULT STDMETHODCALLTYPE Reset( void) = 0;
    
    virtual HRESULT STDMETHODCALLTYPE Clone( 
        /* [out] */ __RPC__deref_out_opt IEnumMoniker **ppenum) = 0;
    
};

class IProgressNotify : public IUnknown
{
public:
    virtual HRESULT STDMETHODCALLTYPE OnProgress( 
        /* [in] */ DWORD dwProgressCurrent,
        /* [in] */ DWORD dwProgressMaximum,
        /* [in] */ RTCPAL_BOOL fAccurate,
        /* [in] */ RTCPAL_BOOL fOwner) = 0;
    
};
 
typedef /* [unique] */  __RPC_unique_pointer IStream *LPSTREAM;
typedef /* [unique] */  __RPC_unique_pointer IMoniker *LPMONIKER;
typedef /* [unique] */  __RPC_unique_pointer IRunningObjectTable *LPRUNNINGOBJECTTABLE;

#endif // __objidl_h__

