

#ifndef __ocidl_h__
#define __ocidl_h__

#ifdef __cplusplus
extern "C"{
#endif 

typedef struct tagPROPPAGEINFO
    {
    ULONG cb;
    LPOLESTR pszTitle;
    SIZE size;
    LPOLESTR pszDocString;
    LPOLESTR pszHelpFile;
    DWORD dwHelpContext;
    } 	PROPPAGEINFO;

typedef struct tagPROPPAGEINFO *LPPROPPAGEINFO;

EXTERN_C const IID IID_IPropertyPage;
class IPropertyPage : public IUnknown
{
public:
};

class IPropertyPageSite : public IUnknown
{
public:
};
typedef IPropertyPageSite *LPPROPERTYPAGESITE;

struct IConnectionPoint;
typedef IConnectionPoint *LPCONNECTIONPOINT;

struct IConnectionPointContainer;
struct IEnumConnectionPoints;
struct IEnumConnections;

typedef struct tagCONNECTDATA
    {
    IUnknown *pUnk;
    DWORD dwCookie;
    } 	CONNECTDATA;
typedef struct tagCONNECTDATA *PCONNECTDATA;
typedef struct tagCONNECTDATA *LPCONNECTDATA;

#define CONNECT_E_FIRST    MAKE_SCODE(SEVERITY_ERROR,   FACILITY_ITF, 0x0200)

#define CONNECT_E_NOCONNECTION      (CONNECT_E_FIRST+0)
#define CONNECT_E_ADVISELIMIT       (CONNECT_E_FIRST+1)
#define CONNECT_E_CANNOTCONNECT     (CONNECT_E_FIRST+2)

EXTERN_C const IID IID_IEnumConnections;
MIDL_INTERFACE("B196B287-BAB4-101A-B69C-00AA00341D07")
IEnumConnections : public IUnknown
{
public:
    virtual /* [local] */ HRESULT STDMETHODCALLTYPE Next( 
        /* [in] */ ULONG cConnections,
        /* [length_is][size_is][out] */ LPCONNECTDATA rgcd,
        /* [out] */ ULONG *pcFetched) = 0;
    
    virtual HRESULT STDMETHODCALLTYPE Skip( 
        /* [in] */ ULONG cConnections) = 0;
    
    virtual HRESULT STDMETHODCALLTYPE Reset( void) = 0;
    
    virtual HRESULT STDMETHODCALLTYPE Clone( 
        /* [out] */ __RPC__deref_out_opt IEnumConnections **ppEnum) = 0;
    
};

EXTERN_C const IID IID_IConnectionPoint;
MIDL_INTERFACE("B196B286-BAB4-101A-B69C-00AA00341D07")
IConnectionPoint : public IUnknown
{
public:
    virtual HRESULT STDMETHODCALLTYPE GetConnectionInterface( 
        /* [out] */ __RPC__out IID *pIID) = 0;
    
    virtual HRESULT STDMETHODCALLTYPE GetConnectionPointContainer( 
        /* [out] */ __RPC__deref_out_opt IConnectionPointContainer **ppCPC) = 0;
    
    virtual HRESULT STDMETHODCALLTYPE Advise( 
        /* [in] */ __RPC__in_opt IUnknown *pUnkSink,
        /* [out] */ __RPC__out DWORD *pdwCookie) = 0;
    
    virtual HRESULT STDMETHODCALLTYPE Unadvise( 
        /* [in] */ DWORD dwCookie) = 0;
    
    virtual HRESULT STDMETHODCALLTYPE EnumConnections( 
        /* [out] */ __RPC__deref_out_opt IEnumConnections **ppEnum) = 0;
    
};

EXTERN_C const IID IID_IEnumConnectionPoints;
MIDL_INTERFACE("B196B285-BAB4-101A-B69C-00AA00341D07")
IEnumConnectionPoints : public IUnknown
{
public:
    virtual /* [local] */ HRESULT STDMETHODCALLTYPE Next( 
        /* [in] */ ULONG cConnections,
        /* [length_is][size_is][out] */ LPCONNECTIONPOINT *ppCP,
        /* [out] */ ULONG *pcFetched) = 0;
    
    virtual HRESULT STDMETHODCALLTYPE Skip( 
        /* [in] */ ULONG cConnections) = 0;
    
    virtual HRESULT STDMETHODCALLTYPE Reset( void) = 0;
    
    virtual HRESULT STDMETHODCALLTYPE Clone( 
        /* [out] */ __RPC__deref_out_opt IEnumConnectionPoints **ppEnum) = 0;
    
};

EXTERN_C const IID IID_IConnectionPointContainer;
MIDL_INTERFACE("B196B284-BAB4-101A-B69C-00AA00341D07")
IConnectionPointContainer : public IUnknown
{
public:
    virtual HRESULT STDMETHODCALLTYPE EnumConnectionPoints( 
        /* [out] */ __RPC__deref_out_opt IEnumConnectionPoints **ppEnum) = 0;
    
    virtual HRESULT STDMETHODCALLTYPE FindConnectionPoint( 
        /* [in] */ __RPC__in REFIID riid,
        /* [out] */ __RPC__deref_out_opt IConnectionPoint **ppCP) = 0;
    
};
 
#ifdef __cplusplus
}
#endif

#include <servprov.h>

#endif


