#if !defined( _OLEAUTO_H_ )
#define _OLEAUTO_H_

#include <guiddef.h>
#include <rpcsal.h>

#ifdef __cplusplus
extern "C" {
#endif

#define WINOLEAPI   HRESULT RTCAPI
#define STDMETHODCALLTYPE RTCAPI

extern const IID GUID_NULL;

typedef WCHAR OLECHAR;
typedef OLECHAR * BSTR, * LPOLESTR;
typedef BSTR * LPBSTR;
typedef const WCHAR * LPCOLESTR;

BSTR
SysAllocString(
    __in_z_opt const OLECHAR * psz
    );

BSTR
SysAllocStringLen(
    __in_ecount_opt(ui) const OLECHAR * strIn,
    unsigned int ui
    );

void
SysFreeString(
    __in_opt BSTR bstrString
    );

unsigned int
SysStringLen(
    __in_opt BSTR
    );

unsigned int
SysStringByteLen(
    __in_opt BSTR bstr
    );

BSTR
SysAllocStringByteLen(
    __in_z_opt const char * psz,
    __in unsigned int len
    );

#define DISPATCH_PROPERTYPUT    0x4

SAFEARRAY * SafeArrayCreate(__in VARTYPE vt, __in UINT cDims, __in SAFEARRAYBOUND * rgsabound);
UINT SafeArrayGetDim(__in SAFEARRAY * psa);
HRESULT SafeArrayGetUBound(__in SAFEARRAY * psa, __in UINT nDim, __out LONG * plUbound);
HRESULT SafeArrayGetLBound(__in SAFEARRAY * psa, __in UINT nDim, __out LONG * plLbound);
HRESULT SafeArrayAccessData(__in SAFEARRAY * psa, __deref_out void ** ppvData);
HRESULT SafeArrayUnaccessData(__in SAFEARRAY * psa);

#define VARCMP_LT   0
#define VARCMP_EQ   1
#define VARCMP_GT   2
#define VARCMP_NULL 3

STDAPI VarBstrCat(__in BSTR bstrLeft, __in BSTR bstrRight, __out LPBSTR pbstrResult);
STDAPI VarBstrCmp(__in BSTR bstrLeft, __in BSTR bstrRight, __in LCID lcid, __in ULONG dwFlags); // dwFlags passed to CompareString

#ifdef __cplusplus
};
#endif

#ifdef __cplusplus
template <class T> 
struct mbu_uuidof
{
   static const IID uuid;
};

#define __uuidof(x) mbu_uuidof<x>::uuid
#define DEFINE_MAC_COM_OBJECT( _class_ ) \
    template<> __attribute__((weak)) const IID mbu_uuidof< _class_ >::uuid( IID_##_class_ )

#endif

#endif // _OLEAUTO_H_

