
#ifndef _WINDOWS_H__
#define _WINDOWS_H__

#include <windef.h>
#include <winerror.h>
#include <winhttp.h>

#ifndef __reserved
#define __reserved
#endif

typedef HANDLE HLOCAL;
#define WINBASEAPI
#define WINAPI  RTCAPI
#define WINAPIV

#include <winnls.h>
#include <winbase.h>
#include <wingdi.h>
#include <winuser.h>
#include <winnt.h>
#include <guiddef.h>
#include <ole2.h>
#include <sspi.h>
#include <mmsystem.h>

typedef ULONG SECURITY_INFORMATION, *PSECURITY_INFORMATION;
typedef ULONG ACCESS_MASK;
typedef ACCESS_MASK *PACCESS_MASK;

#include <winreg.h>

#define __CSADDR_DEFINED__

typedef DWORD (RTCAPI *PTHREAD_START_ROUTINE)(
    LPVOID lpThreadParameter
    );
typedef PTHREAD_START_ROUTINE LPTHREAD_START_ROUTINE;

typedef struct sockaddr SOCKADDR, * LPSOCKADDR, * PSOCKADDR;
typedef struct sockaddr_in SOCKADDR_IN, * LPSOCKADDR_IN, * PSOCKADDR_IN;
typedef struct sockaddr_in6 SOCKADDR_IN6, * LPSOCKADDR_IN6, * PSOCKADDR_IN6;
typedef struct sockaddr_storage SOCKADDR_STORAGE, * LPSOCKADDR_STORAGE, * PSOCKADDR_STORAGE;
typedef struct in6_addr IN6_ADDR;
typedef struct in_addr IN_ADDR;

/*
 * SockAddr Information
 */
typedef struct SOCKET_ADDRESS {
    __field_bcount(iSockaddrLength) SOCKADDR * lpSockaddr;
    int iSockaddrLength;
} SOCKET_ADDRESS, *PSOCKET_ADDRESS, * LPSOCKET_ADDRESS;

/*
 * Address list returned via SIO_ADDRESS_LIST_QUERY
 */
typedef struct SOCKET_ADDRESS_LIST {
    int             iAddressCount;
    SOCKET_ADDRESS  Address[1];
} SOCKET_ADDRESS_LIST, *PSOCKET_ADDRESS_LIST, * LPSOCKET_ADDRESS_LIST;

// for accessing IPv6 address via 16-bit array
#if defined(ANDROID) || defined(__linux)
#define s6_words  s6_addr16
#define s6_bytes   s6_addr
#else
#define s6_words    __u6_addr.__u6_addr16
#define s6_bytes    __u6_addr.__u6_addr8
#endif

#endif // _WINDOWS_H__

