
#include "rpc.h"
#include "rpcndr.h"
#include "rtcpal_windows.h"

#ifndef __unknwn_h__
#define __unknwn_h__

EXTERN_C const IID IID_IUnknown;

#ifdef __cplusplus
class IUnknown
{
public:
    virtual HRESULT STDMETHODCALLTYPE QueryInterface( 
        /* [in] */ REFIID riid,
        /* [iid_is][out] */ 
        __RPC__deref_out  void **ppvObject) = 0;
    
    virtual ULONG STDMETHODCALLTYPE AddRef( void) = 0;
    
    virtual ULONG STDMETHODCALLTYPE Release( void) = 0;

    template <class Q>
    HRESULT QueryInterface(Q ** pp) {
        return QueryInterface(__uuidof(Q), (void **)pp);
    }
};

typedef IUnknown * LPUNKNOWN;


EXTERN_C const IID IID_IClassFactory;

MIDL_INTERFACE("00000001-0000-0000-C000-000000000046")
IClassFactory : public IUnknown
{
public:
    virtual /* [local] */ HRESULT STDMETHODCALLTYPE CreateInstance( 
        /* [unique][in] */ IUnknown *pUnkOuter,
        /* [in] */ REFIID riid,
        /* [iid_is][out] */ void **ppvObject) = 0;
    
    virtual /* [local] */ HRESULT STDMETHODCALLTYPE LockServer( 
        /* [in] */ RTCPAL_BOOL fLock) = 0;
    
};
#endif // __cplusplus

#endif // __unknwn_h__
