#ifndef _WINNLS_
#define _WINNLS_

#ifdef __cplusplus
extern "C" {
#endif

#ifndef CP_UTF8
#define CP_UTF8     65001
#endif

#ifndef CP_ACP
#define CP_ACP      0
#endif

#ifndef CP_OEMCP
#define CP_OEMCP    1
#endif

#ifndef CP_MACCP
#define CP_MACCP    2
#endif

#ifndef CP_THREAD_ACP
#define CP_THREAD_ACP   3
#endif

#define MB_PRECOMPOSED            0x00000001  // use precomposed chars
#define MB_COMPOSITE              0x00000002  // use composite chars
#define MB_USEGLYPHCHARS          0x00000004  // use glyph chars, not ctrl chars
#define MB_ERR_INVALID_CHARS      0x00000008  // error for invalid chars

WINBASEAPI
int
WINAPI
MultiByteToWideChar(
    __in UINT     CodePage,
    __in DWORD    dwFlags,
    __in_bcount(cbMultiByte) LPCSTR   lpMultiByteStr,
    __in int      cbMultiByte,
    __out_ecount_opt(cchWideChar) __transfer(lpMultiByteStr) LPWSTR  lpWideCharStr,
    __in int      cchWideChar
    );

WINBASEAPI
int
WINAPI
WideCharToMultiByte(
    __in UINT     CodePage,
    __in DWORD    dwFlags,
    __in_ecount(cchWideChar) LPCWSTR  lpWideCharStr,
    __in int      cchWideChar,
    __out_bcount_opt(cbMultiByte) __transfer(lpWideCharStr) LPSTR   lpMultiByteStr,
    __in int      cbMultiByte,
    __in_opt LPCSTR   lpDefaultChar,
    __out_opt LPRTCPAL_BOOL  lpUsedDefaultChar
    );

#define LOCALE_INVARIANT            0x20000000
#define NORM_IGNORECASE             0x00000001  // ignore case

#define MAKELANGID(p, s)       ((((WORD  )(s)) << 10) | (WORD  )(p))
#define MAKELCID(lgid, srtid)  ((DWORD)((((DWORD)((WORD  )(srtid))) << 16) |  \
                                         ((DWORD)((WORD  )(lgid)))))

#define LANG_NEUTRAL                     0x00
#define SUBLANG_NEUTRAL                             0x00    // language neutral
#define SUBLANG_DEFAULT                             0x01    // user default
#define SORT_DEFAULT                     0x0     // sorting default

#define LANG_USER_DEFAULT      (MAKELANGID(LANG_NEUTRAL, SUBLANG_DEFAULT))

#define LOCALE_USER_DEFAULT    (MAKELCID(LANG_USER_DEFAULT, SORT_DEFAULT))

#define CSTR_EQUAL                2           // string 1 equal to string 2

typedef DWORD LCID;         

int
WINAPI
CompareStringA(
    __in LCID     Locale,
    __in DWORD    dwCmpFlags,
    __in_ecount(cchCount1) LPCSTR  lpString1,
    __in int      cchCount1,
    __in_ecount(cchCount2) LPCSTR  lpString2,
    __in int      cchCount2);
int
WINAPI
CompareStringW(
    __in LCID     Locale,
    __in DWORD    dwCmpFlags,
    __in_ecount(cchCount1) LPCWSTR  lpString1,
    __in int      cchCount1,
    __in_ecount(cchCount2) LPCWSTR  lpString2,
    __in int      cchCount2);
#ifdef UNICODE
#define CompareString  CompareStringW
#else
#define CompareString  CompareStringA
#endif // !UNICODE


#ifdef __cplusplus
}
#endif

#endif // _WINNLS_

