#pragma once
/* --

Copyright (c) Microsoft Corporation. All rights reserved.

Module Name:

    mmvr_ORTC.h

Abstract:

    ORTC MMVR renderer outward facing API.

--*/


#ifndef __MMVR_ORTC__
#define __MMVR_ORTC__


#include <mmvr_Common.h>
#include <ortcintegration.h>

#ifdef __cplusplus
extern "C" {
#endif

// =============================================================================
// Enums
// =============================================================================


// ============================================================================
// PAL Companion Supporting classic ORTC mmvr
// ============================================================================

// ----------------------------------------------------------------------------
// HANDLES Specific to the ORTC API's
// ----------------------------------------------------------------------------
typedef struct ORTCRenderer * HMEDIAVRORTC;

// ----------------------------------------------------------------------------
// MediaVRCreateORTCRenderer
//
// Create and retrieve a handle to an ORTC Renderer
// ----------------------------------------------------------------------------
HRESULT __stdcall MediaVRCreateORTCRenderer(
    __out HMEDIAVRORTC * phVideoRenderer,
    __in IOrtcSourceStreamOnSampleCallback * pCallback);


// ----------------------------------------------------------------------------
// MediaVRDestroyORTCRenderer
//
// Destroy an ORTC Renderer
// ----------------------------------------------------------------------------
HRESULT __stdcall MediaVRDestroyORTCRenderer(__in HMEDIAVRORTC hMMediaVRORTC);


// ----------------------------------------------------------------------------
// MediaVRGetORTCRenderContext
//
// Retrieve the render context to be used in creation of the sink.
// ----------------------------------------------------------------------------
HRESULT __stdcall MediaVRGetORTCRenderContext(__in HMEDIAVRORTC hMMediaVRORTC, __out const void ** ppVoidContext);


#ifdef __cplusplus
}; // extern "C"
#endif

#endif //__MMVR_ORTC__
