#pragma once
#ifndef __MMVR_IVIDEOWINDOW__
#define __MMVR_IVIDEOWINDOW__

// ============================================================================
// PAL Companion Supporting classic IVideoWindow form
// ============================================================================

// ----------------------------------------------------------------------------
// HANDLES Specific to the IVideo Window API's
// ----------------------------------------------------------------------------

// foaward declaration, to avoid dependency
struct RtcPalVideoWidowRenderer;

typedef struct RtcPalVideoWidowRenderer*  HPALVIDEOIVIDEOWINDOW;

// ----------------------------------------------------------------------------
// MMVRCreateIVideoWindowRenderer
//
// Create and retrieve a handle to an IVideoWindow Renderer
// ----------------------------------------------------------------------------

HRESULT
MMVRCreateIVideoWindowRenderer(
    __in    DWORD dwFlags,
    __out   HPALVIDEOIVIDEOWINDOW* phVideoRenderer
);

// ----------------------------------------------------------------------------
// MMVRGetVideoWindowContext
//
// Retrieve the rendering context to be used in creation of the sink.
// ----------------------------------------------------------------------------

HRESULT
MMVRGetVideoWindowContext(
    __in    HPALVIDEOIVIDEOWINDOW hVideoRenderer,
    __out   const void **ppvRenderContext
);

// ----------------------------------------------------------------------------
// MMVRGetIVideoWindow
//
// Retrieve the underlying IVideoWindow pointer used by the renderer.
// ----------------------------------------------------------------------------

HRESULT
MMVRGetIVideoWindow(
    __in   HPALVIDEOIVIDEOWINDOW hVideoRenderer,
    __out   void **ppIVideoWindow
);





// ----------------------------------------------------------------------------
// MMVRDestroyIVideoWindowRenderer
//
// Destroys the IVideoWindow MMVR object
// ----------------------------------------------------------------------------

HRESULT
MMVRDestroyIVideoWindowRenderer(
    __in   HPALVIDEOIVIDEOWINDOW hVideoRenderer
);

#endif //__MMVR_IVIDEOWINDOW__
