#pragma once

// Copyright (C) Microsoft Corporation. All rights reserved.

#include <mfidl.h>

class IRtcPalVideoPlatformExtensionORTC
{
public:
    virtual ~IRtcPalVideoPlatformExtensionORTC() { }
    virtual HRESULT AddSource(IMFMediaSource* pMFSource) = 0;
    virtual HRESULT RemoveSource(IMFMediaSource* pMFSource) = 0;
    virtual HRESULT GetSourceCount(int* pCount) const = 0;
};

class IRtcPalVideoPlatformExtensionORTCTest
{
public:
    struct ICallback
    {
        virtual ~ICallback() { }
        virtual HRESULT GetExtensionFromMFSource(IMFMediaSource* pMFSource, REFGUID id, void** ppExt) = 0;
    };

    virtual ~IRtcPalVideoPlatformExtensionORTCTest() { }

    // Generic testing
    virtual HRESULT SetCallback(ICallback* pCallback) = 0;
    virtual HRESULT CreatePhysicalMFSource(IMFMediaSource** ppMFSource, int index = -1, const wchar_t* name = 0) const = 0;

    // Pre-configured testing
    virtual HRESULT SetUpPreConfiguredORTCTest() = 0; // AddSource(CreatePhysicalMFSource())
    virtual HRESULT IsPreConfiguredORTCTest(bool* pPreconf) = 0;
};
