#pragma once

#ifndef CREATE_EVENT_MANUAL_RESET
#define CREATE_EVENT_MANUAL_RESET 1
#endif

#ifndef CREATE_EVENT_INITIAL_SET
#define CREATE_EVENT_INITIAL_SET  2
#endif

//{ IO port
BOOL
WINAPI
GetQueuedCompletionStatusEx(
  __in   HANDLE CompletionPort,
  __out  LPOVERLAPPED_ENTRY lpCompletionPortEntries,
  __in   ULONG ulCount,
  __out  PULONG ulNumEntriesRemoved,
  __in   DWORD dwMilliseconds,
  __in   BOOL fAlertable
);

BOOL
WINAPI
CancelIoEx(
  __in      HANDLE hFile,
  __in_opt  LPOVERLAPPED lpOverlapped
);
//}

#ifdef __cplusplus
extern "C"
{
#endif

HANDLE 
WINAPI 
CreateEventExW(
  __in_opt  LPSECURITY_ATTRIBUTES lpEventAttributes,
  __in_opt  LPCTSTR lpName,
  __in      DWORD dwFlags,
  __in      DWORD dwDesiredAccess
);

DWORD 
WINAPI 
GetThreadId(HANDLE Thread);

//{ ThreadPool
#ifdef __cplusplus
struct ThreadPoolWork
{
    PTP_WORK_CALLBACK m_pCallback;
    PVOID m_pUserData;
    PTP_CALLBACK_ENVIRON m_pCallbackEnv;
    HANDLE m_hFinishEvent;
    volatile bool m_fSubmitted;
    
    ThreadPoolWork(
        PTP_WORK_CALLBACK pCallback, 
        PVOID pUserData, 
        PTP_CALLBACK_ENVIRON pCallbackEnv
        ) : m_pCallback(pCallback), 
            m_pUserData(pUserData), 
            m_pCallbackEnv(pCallbackEnv),
            m_fSubmitted(false)
    {
        m_hFinishEvent = ::CreateEvent(NULL, TRUE/*bManualReset*/, FALSE/*bInitialState*/, NULL);
    }
    
    ~ThreadPoolWork() 
    {
        if(m_hFinishEvent)
        {
            ::CloseHandle(m_hFinishEvent);
        }
    }
};

PTP_WORK 
WINAPI 
CreateThreadpoolWork(
  __in         PTP_WORK_CALLBACK pfnwk,
  __inout_opt  PVOID pv,
  __in_opt     PTP_CALLBACK_ENVIRON pcbe
);

WINBASEAPI
VOID 
WINAPI 
WaitForThreadpoolWorkCallbacks(
  __inout  PTP_WORK pwk,
  __in     BOOL fCancelPendingCallbacks
);

VOID 
WINAPI 
CloseThreadpoolWork(
  __inout  PTP_WORK pwk
);

VOID 
WINAPI 
SubmitThreadpoolWork(
  __inout  PTP_WORK pwk
);
#endif
//}

//{ SWRLock
#ifdef SRWLOCK
#undef SRWLOCK
#endif
#define SRWLOCK RTCPAL_SLIM_LOCK

#define InitializeSRWLock(lock)         RtcPalInitializeSlimLock(lock)
#define AcquireSRWLockShared(lock)      RtcPalAcquireSlimLock(lock)
#define AcquireSRWLockExclusive(lock)   RtcPalAcquireSlimLock(lock)
#define ReleaseSRWLockShared(lock)      RtcPalReleaseSlimLock(lock)
#define ReleaseSRWLockExclusive(lock)   RtcPalReleaseSlimLock(lock)
//}

#ifdef __cplusplus
}
#endif
