#pragma once

#ifndef __MMVR_SL_H__
#define __MMVR_SL_H__

class MMVR_SLRenderer;

typedef MMVR_SLRenderer* HMMVRSLRENDERER;

typedef struct _SLSampleInfo
{
    DWORD dwBufLen;
    DWORD fourCC;
    DWORD dwWidth;
    DWORD dwHeight;
    uint64_t ullTimeStamp;
    struct
    {
        BOOL IsKeyFrame;
    } VC1;
    
} SLSampleInfo;

struct _RtcPalVideoHWSampleSL_t;

typedef void (*PFNDELETESLHWSAMPLE)(_RtcPalVideoHWSampleSL_t *pSample);


typedef struct _RtcPalVideoHWSampleSL_t : public RtcPalVideoHWSample_t
{
    _RtcPalVideoHWSampleSL_t(PFNDELETESLHWSAMPLE pfnDel) 
    {
        eType = RtcPalVideoHWSample_SL;
        
        pfnDelete = pfnDel;
    }
    
    PFNDELETESLHWSAMPLE pfnDelete;
} RtcPalVideoHWSampleSL_t;


 

typedef struct _DecoderInitInfo
{
    uint32_t fourCC;
    uint32_t maxHeight;
    uint32_t maxWidth;

    struct
    {
        // Frame header (optional, header can also be in the data)
        uint8_t  pbFrameHeader[65];
        uint32_t ulHeaderLength;

        // Codec flag (RTVideo only)
        uint32_t ulCodecFlag;
    } VC1;

    _DecoderInitInfo();

} DecoderInitInfo;



#endif // __MMVR_SL_H__
